Imports System.Text
Imports System.Threading
Imports System.Runtime.InteropServices
Imports fxcore2
Imports System.IO

#Const DataPump = False   ' True -> DataPump  False -> TradePump   ' *** Need to change assembly name to/from "FXCM Data Server" and "FXCM Forex Broker" in My Project
#Const FULLBIDASKDATA = 1  ' 0=none  1=Bid/ask  2=OHLC formed from bid and ask, bid OHLC & ask OHLC
#Const DataLogFile = False

Public Class FXCM
    Private mSession As O2GSession
    Private statusListener As mySessionStatusListener
    Private responseListener As ResponseListener
    Private Shared AccountID As String = ""

    Private UserId As String
    Private Password As String

    Public Shared strSessionID As String = ""
    Public Shared strPin As String = ""
    Public Shared AccountBalance As Double = -2
    Public Shared USAccount As Boolean
    Public Shared DemoAccount As Boolean = True

    <DllImport("Kernel32")> _
    Private Shared Function SetConsoleCtrlHandler(ByVal handler As EventHandler, ByVal add As Boolean) As Boolean
    End Function
    Public Delegate Function EventHandler(ByVal sig As CtrlType) As Boolean
    Public Shared _handler As EventHandler
    Public Enum CtrlType
        CTRL_C_EVENT = 0
        CTRL_BREAK_EVENT = 1
        CTRL_CLOSE_EVENT = 2
        CTRL_LOGOFF_EVENT = 5
        CTRL_SHUTDOWN_EVENT = 6
    End Enum

    Public Shared Function Handler(ByVal sig As CtrlType) As Boolean
        SetConsoleCtrlHandler(New EventHandler(AddressOf Handler), True)

        Select Case sig
            Case CtrlType.CTRL_C_EVENT, CtrlType.CTRL_BREAK_EVENT, CtrlType.CTRL_LOGOFF_EVENT, CtrlType.CTRL_SHUTDOWN_EVENT, CtrlType.CTRL_CLOSE_EVENT
                Return True
            Case Else
                Return False
        End Select
    End Function

#If False Then
    Shared Sub TestFXCM()
        'Dim strUserID As String = "1879234" 'args(0)
        'Dim strPassword As String = "3270" 'args(1)
        Dim strUserID As String = "D172263948001" 'args(0)
        Dim strPassword As String = "8084" 'args(1)
        Dim strURL As String = "http://www.fxcorporate.com/Hosts.jsp" 'args(2)
        Dim strConnection As String = "Demo" 'args(3)
        'strSessionID = "" 'args(4)
        'strPin = "" 'args(5)

        Try
            Dim session As O2GSession = O2GTransport.createSession()
            Dim statusListener As New mySessionStatusListener(session)
            session.subscribeSessionStatus(statusListener)
            session.login(strUserID, strPassword, strURL, strConnection)
            Do While (Not statusListener.Connected) AndAlso (statusListener.Error Is Nothing)  'Not statusListener.Error
                Thread.Sleep(50)
            Loop
            If (statusListener.Error Is Nothing) Then  'Not statusListener.Error Then
                session.logout()
                Do While Not statusListener.Disconnected
                    Thread.Sleep(50)
                Loop
            Else
                MsgBox(statusListener.Error, MsgBoxStyle.SystemModal)
            End If
            session.unsubscribeSessionStatus(statusListener)
            MsgBox("Done! Press any key to exit")
            session.Dispose()
        Catch e As Exception
            MsgBox("Exception: " + e.ToString(), MsgBoxStyle.SystemModal)
        End Try
    End Sub
#End If

    Public Function Logon(strUserID As String, strPassword As String) As Boolean
        Dim strURL As String = "http://www.fxcorporate.com/Hosts.jsp"
        'Dim strConnection As String = "Demo"
        Dim strConnection As String = "Real"
        Dim i As Long
        Dim starti As Long = 1
        Dim endi As Long = 4
        Dim txt As String

        If strUserID <> "" And strPassword <> "" Then
            ' remember password in case disconnect/reconnect in future
            UserId = strUserID
            Password = strPassword
        End If

        If WasLoggedOnIndex > 0 Then
            ' if logged on before, then skip trying of real/demo account and jump right to one that worked before
            starti = WasLoggedOnIndex
            endi = WasLoggedOnIndex
        End If

        Try
            AccountID = strUserID
            ' loop thru login twice, once trying as Real account and once trying as Demo account
            For i = starti To endi
                If i = 1 Or i = 3 Then
                    strConnection = "Real"
                Else
                    strConnection = "Demo"
                End If

                mSession = O2GTransport.createSession()
                statusListener = New mySessionStatusListener(mSession)
                responseListener = New ResponseListener(mSession)
                mSession.subscribeResponse(responseListener)
                mSession.subscribeSessionStatus(statusListener)
                mSession.login(UserId, Password, strURL, strConnection)
                Do While (Not statusListener.Connected) AndAlso (statusListener.Error Is Nothing)  'Not statusListener.Error
                    Thread.Sleep(50)
                Loop
                If statusListener.Connected = True Then
#If DataPump Then
                    ' tell computer not to hibernate/sleep while data being received (FXCM connection gets messed up for some reason)
                    PowerManager.PowerSaveOn()
#End If
                    WasLoggedOn = True
                    WasLoggedOnIndex = i
                    LogonErrorMessageDisplayed = False
                    Logon = True
                    DemoAccount = strConnection <> "Real"
                    Exit Function
                ElseIf i > 2 And statusListener.Error IsNot Nothing Then
                    'If InStr(statusListener.Error, "User or connection doesn't exist") = 0 Then
                    ' error other than connecting to wrong account type (i.e. Real vs Demo)
                    Exit For
                    'End If
                End If
            Next i
            If statusListener.Error IsNot Nothing Then
                If Not LogonErrorMessageDisplayed Then  ' only show error messages once per logon failure
                    txt = Chr(13) + Chr(13) + "If this occurs over a weekend, the FXCM servers may be shutdown for weekend maintenance.  FXCM server maintenance starts after 4:00 PM Friday EST, usually by 5:00 PM, and can continue through the weekend. On many weekends the FXCM server maintenance ends by Saturday afternoon. You will be able to login to FXCM after server maintenance ends, and start trading after the 5:15 PM EST trading open on Sunday."
                    If InStr(statusListener.Error, "HTTP send request failed") > 0 Then
                        If WasLoggedOn Then
                            txt = "NeuroShell Trader was disconnected with the FXCM server and is unable to reconnect.  Please make sure that you still have a live Internet connection." + txt + Chr(13) + Chr(13) + "[HTTP send request failed]"
                        Else
                            txt = "NeuroShell Trader was unable to connect with the FXCM server.  Please make sure that you have a live Internet connection and no firewalls or anti-virus programs are blocking NeuroShell's access, then try again." + txt + Chr(13) + Chr(13) + "[HTTP send request failed]"
                        End If
                    ElseIf InStr(statusListener.Error, "Wrong user name or password") > 0 Then
                        txt = "Wrong FXCM user name or password"
                    ElseIf InStr(statusListener.Error, "weekend") > 0 And InStr(statusListener.Error, "maintenance") > 0 Then
                        txt = "FXCM Login Error: " + Chr(13) + Chr(13) + statusListener.Error + "   [" + CStr(i) + "]"
                    ElseIf InStr(statusListener.Error, "HTTP receive response failed") > 0 Then
                        If WasLoggedOn Then
                            txt = "NeuroShell Trader was disconnected with the FXCM server and is unable to reconnect ." + txt + Chr(13) + Chr(13) + "[HTTP receive response failed]"
                        Else
                            txt = "NeuroShell Trader was unable to connect with the FXCM server." + txt + Chr(13) + Chr(13) + "[HTTP receive response failed]"
                        End If
                    Else
                        txt = "FXCM Login Error: " + statusListener.Error + Chr(13) + Chr(13) + "NeuroShell Trader was unable to connect with the FXCM server." + txt
                    End If
                    LogFile("########## FXCM Logon Error:  " + Replace(txt, Chr(13), " "))
                    MsgBox(txt, MsgBoxStyle.SystemModal)
                    LogonErrorMessageDisplayed = True
                End If
            End If
        Catch e As Exception
            If Not LogonErrorMessageDisplayed Then  ' only show error messages once per logon failure
                LogFile("########## FXCM Logon Exception: " + e.ToString())
                MsgBox("FXCM Logon Exception: " + Chr(13) + Chr(13) + e.ToString(), MsgBoxStyle.SystemModal)
                LogonErrorMessageDisplayed = True
            End If
        End Try

        Logon = False
    End Function

    Public Sub Logoff()
        Try
            If statusListener.Error Is Nothing Then  'Not statusListener.Error Then
                mSession.logout()
                Do While Not statusListener.Disconnected
                    Thread.Sleep(50)
                Loop
            End If
            mSession.unsubscribeSessionStatus(statusListener)
            mSession.unsubscribeResponse(responseListener)
            mSession.Dispose()
#If DataPump Then
            ' tell computer it's okay to hibernate/sleep again (FXCM connection was getting messed up for some reason if computer went to sleep)
            PowerManager.PowerSaveOff()
#End If
        Catch e As Exception
            LogFile("Logoff Exception: " + e.ToString())
            MsgBox("Logoff Exception: " + e.ToString(), MsgBoxStyle.SystemModal)
        End Try
    End Sub

#If DataPump Then
    Public Sub GetHistoricalData(strInstrument As String, BarInterval As Single, Description As String, Category As String, strFirstDateTime As String)
        Dim dtFrom As Date = Date.FromOADate(0)
        Dim dtTo As Date = Date.FromOADate(0)  ' start with 0 as dtTo so that data loaded up to most recent bar
        Dim strTimeFrame As String = ""
        Dim absBarInterval As Single
        Dim percent As Integer
        Dim lastpercent As Integer = -1
        Dim converter As O2GTimeConverter = mSession.getTimeConverter()
        Dim intervals As Integer
        Dim datearray(1) As Double
        Dim openarray(1) As Double
        Dim higharray(1) As Double
        Dim lowarray(1) As Double
        Dim closearray(1) As Double
        Dim volumearray(1) As Double
#If FULLBIDASKDATA > 0 Then
        Dim bidopenarray(1) As Double
        Dim bidhigharray(1) As Double
        Dim bidlowarray(1) As Double
        Dim bidclosearray(1) As Double
        Dim askopenarray(1) As Double
        Dim askhigharray(1) As Double
        Dim asklowarray(1) As Double
        Dim askclosearray(1) As Double
#End If
        Dim barsallocated As Integer = 0
        Dim barcount As Integer = 0
        Dim i As Integer
        Dim LastBarTime As Date = Date.FromOADate(0)
        Dim LastBarTimeCount As Integer = 0
        Dim LastTickTime As Date = Date.FromOADate(0)
        Dim LastTickVolume As Double = 0
        Dim olddate As Double = 0
        Dim ret As Boolean = False
        Dim responselistenergetflag As Boolean = False
        Dim histreader As O2GMarketDataSnapshotResponseReader
        Dim nextdtTo As Date
        Dim FivePM As Date = Date.FromOADate(0.70833333333333)
        Dim msgboxflag As Boolean = True

        ' Convert strFirstDateTime string to date value
        Try
            If strFirstDateTime <> "" Then dtFrom = Convert.ToDateTime(strFirstDateTime)
        Catch
            dtFrom = Date.FromOADate(0)
        End Try

        ' convert BarInterval to FXCM timeframe
        absBarInterval = Math.Abs(BarInterval)
        If absBarInterval = 0 Then
            strTimeFrame = "t1"
        ElseIf absBarInterval > 10080 Then
            strTimeFrame = "M1"   ' month
        ElseIf absBarInterval = 10080 Then
            strTimeFrame = "W1"   ' week
        ElseIf absBarInterval = 1440 Then
            strTimeFrame = "D1"   ' day
        ElseIf absBarInterval Mod 60 = 0 Then
            intervals = CInt(absBarInterval / 60)
            If intervals = 1 Or intervals = 2 Or intervals = 4 Or intervals = 6 Or intervals = 8 Then
                ' use FXCM native hour bars for 1,2,4,6 or 8 hour bars (others FXCM doesn't support?!)
                strTimeFrame = "H" + CStr(absBarInterval / 60)
            Else
                strTimeFrame = "H1" ' load 1 hour bars and let NST convert to proper size
            End If
        Else
            ' use FXCM native hour bars for 1,2,4,6 or 8 hour bars (others FXCM doesn't support?!)
            intervals = CInt(absBarInterval)
            If intervals = 1 Or intervals = 5 Or intervals = 15 Or intervals = 30 Then
                ' use FXCM native hour bars for 1,5,15 or 30 minutes (others FXCM doesn't support?!)
                strTimeFrame = "m" + CStr(absBarInterval)        ' minutes
            ElseIf intervals Mod 30 = 0 Then
                strTimeFrame = "m30"  ' load 1 minute bars and let NST convert to proper size
                If DataServerType = 2 Then BarInterval = 30 Else BarInterval = -30 ' reset NST data pump bar interval for size actually being received
            ElseIf intervals Mod 15 = 0 Then
                strTimeFrame = "m15"  ' load 1 minute bars and let NST convert to proper size
                If DataServerType = 2 Then BarInterval = 15 Else BarInterval = -15 ' reset NST data pump bar interval for size actually being received
            ElseIf intervals Mod 5 = 0 Then
                strTimeFrame = "m5"  ' load 1 minute bars and let NST convert to proper size
                If DataServerType = 2 Then BarInterval = 5 Else BarInterval = -5 ' reset NST data pump bar interval for size actually being received
            Else
                strTimeFrame = "m1"  ' load 1 minute bars and let NST convert to proper size
                If DataServerType = 2 Then BarInterval = 1 Else BarInterval = -1 ' reset NST data pump bar interval for size actually being received
            End If
            absBarInterval = Math.Abs(BarInterval)
        End If

        ' Start buffering of incoming ticks while historical data request is being processed (to eliminate gap or overlap between ticks in most recent historical bar and realtime ticks)
        If DataServerType = 1 Then DataPump_HistoricalTickBufferStart(strInstrument, BarInterval)

        Try
            nextdtTo = dtTo

#If DataLogFile Then
            LogFile("Getting " + strInstrument + " with timeframe " + strTimeFrame + " and NSTBarInterval " + CStr(BarInterval) + " from " + CStr(dtFrom) + " to " + CStr(dtTo))
#End If
            Do
                If (Not statusListener.Connected) Or (responseListener Is Nothing) Then
                    If Not WasLoggedOn Then
                        ' first logon failed, so just abort
#If DataLogFile Then
                        LogFile("History Load Failed - First logon failed")
#End If
                        UpdatePercent2(100)  ' notify NST that data loading is done
                        Exit Sub
                    End If

                    ' try to logon again
                    If Not Logon("", "") Then
#If DataLogFile Then
                        LogFile("History Load Failed - Unable to logon")
#End If
                        UpdatePercent2(100)  ' notify NST that data loading is done
                        Exit Sub
                    End If
                End If

                If statusListener.Error IsNot Nothing Then
                    ' DRW 8/20/2014 attempt to get rid of system.exceptions in responselistener.get when FXCM doing weekly maintenance and NST tried to get historical data or realtime updates
                    UpdatePercent2(100)  ' notify NST that data loading is done
                    Exit Sub
                End If

#If DataLogFile Then
                LogFile("Start responseListener.get(" + strInstrument + ", " + strTimeFrame + ", " + CStr(dtFrom) + ", " + CStr(nextdtTo) + ")")
#End If
                responselistenergetflag = True
                ret = responseListener.get(strInstrument, strTimeFrame, dtFrom, nextdtTo, False, 15)
                responselistenergetflag = False
#If DataLogFile Then
                LogFile("Finished responseListener.get(" + strInstrument + ", " + strTimeFrame + ", " + CStr(dtFrom) + ", " + CStr(nextdtTo) + ")")
#End If
                If ret Then
                    If responseListener.Reader IsNot Nothing Then
                        histreader = responseListener.Reader

                        If histreader.Count = 0 Then
#If DataLogFile Then
                            LogFile("Exit due to " + CStr(histreader.Count) + " items in HistResponseListener.Reader")
#End If
                            Exit Do
                        ElseIf histreader.Count = 1 Then
                            If histreader.getDate(0) > nextdtTo And nextdtTo > Date.FromOADate(0) Then
#If DataLogFile Then
                                LogFile("Exit due to " + CStr(histreader.Count) + " items in HistResponseListener.Reader and date of " + histreader.getDate(0).ToString + " is greater than request range ... i.e. FXCM data doesn't go back as far as request range")
#End If
                                Exit Do
                            End If
                        End If
#If DataLogFile Then
                        LogFile("Processing " + CStr(histreader.Count) + " items in HistResponseListener.Reader from " + histreader.getDate(0).ToString + " to " + histreader.getDate(histreader.Count - 1).ToString)
#End If

                        If barcount + histreader.Count >= barsallocated Then
                            If barsallocated < 100 Then
                                barsallocated = 5000
                            ElseIf barsallocated < 100000 Then
                                barsallocated = barsallocated * 2
                            Else
                                barsallocated = CInt(barsallocated * 1.25)
                            End If
                            ReDim Preserve datearray(barsallocated)
                            If absBarInterval <> 0 Then
                                ReDim Preserve openarray(barsallocated)
                                ReDim Preserve higharray(barsallocated)
                                ReDim Preserve lowarray(barsallocated)
#If FULLBIDASKDATA > 0 Then
                                ReDim Preserve bidopenarray(barsallocated)
                                ReDim Preserve bidhigharray(barsallocated)
                                ReDim Preserve bidlowarray(barsallocated)
                                ReDim Preserve bidclosearray(barsallocated)
                                ReDim Preserve askopenarray(barsallocated)
                                ReDim Preserve askhigharray(barsallocated)
                                ReDim Preserve asklowarray(barsallocated)
                                ReDim Preserve askclosearray(barsallocated)
#End If
                            End If
                            ReDim Preserve closearray(barsallocated)
                            ReDim Preserve volumearray(barsallocated)
                        End If

                        If barcount = 0 Then
                            ' no historical collected yet
                            dtTo = histreader.getDate(histreader.Count - 1)    ' set dtTo with last bar date for percentage calculation below
                            LastBarTime = dtTo

                            If DataServerType = 1 Then
                                If absBarInterval <> 0 Then
                                    ' find out the time stamp and volume of the last tick included in the historical bars (for merging of historical with incoming tick stream)
                                    LastTickTime = converter.convert(histreader.getLastBarTime(), O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST)   ' Convert from UTC time to EST time
                                    LastTickVolume = histreader.getLastBarVolume()
                                Else
                                    ' find out the time stamp and volume of the last tick included in the historical bars (for merging of historical with incoming tick stream)
                                    LastTickTime = converter.convert(histreader.getDate(histreader.Count - 1), O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST)   ' Convert from UTC time to EST time
                                    LastTickVolume = histreader.getVolume(histreader.Count - 1)
                                End If
                            Else
                                'If absBarInterval = 0 Then
                                '' count the number of bars in last time stamp (i.e last second for tick bars)
                                'LastBarTimeCount = 0
                                'For i = histreader.Count - 1 To 0 Step -1
                                'If histreader.getDate(i) <> histreader.getDate(histreader.Count - 1) Then Exit For
                                'LastBarTimeCount = LastBarTimeCount + 1
                                'Next i
                                'End If
                            End If
                        End If

                        If absBarInterval <> 0 Then
                            For i = histreader.Count - 1 To 0 Step -1
                                ' NOTE: FXCM already sends daily dates with the expiration time in it (9pm UTC, which equals 5pm Eastern)
                                datearray(barcount) = (converter.convert(histreader.getDate(i), O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST).AddMinutes(absBarInterval).ToOADate())   ' adjust date/time from start of bar timestamp to end of bar timestamp
#If FULLBIDASKDATA = 1 Then
                                openarray(barcount) = histreader.getBidOpen(i)
                                higharray(barcount) = histreader.getBidHigh(i)
                                lowarray(barcount) = histreader.getBidLow(i)
                                closearray(barcount) = histreader.getBidClose(i)
                                volumearray(barcount) = histreader.getVolume(i)

                                bidopenarray(barcount) = histreader.getBidOpen(i)
                                bidhigharray(barcount) = histreader.getBidHigh(i)
                                bidlowarray(barcount) = histreader.getBidLow(i)
                                bidclosearray(barcount) = histreader.getBidClose(i)
                                askopenarray(barcount) = histreader.getAskOpen(i)
                                askhigharray(barcount) = histreader.getAskHigh(i)
                                asklowarray(barcount) = histreader.getAskLow(i)
                                askclosearray(barcount) = histreader.getAskClose(i)
#ElseIf FULLBIDASKDATA = 2 Then
                            openarray(barcount) = (histreader.getBidOpen(i) + histreader.getAskOpen(i)) / 2
                            higharray(barcount) = histreader.getAskHigh(i)
                            lowarray(barcount) = histreader.getBidLow(i)
                            closearray(barcount) = (histreader.getBidClose(i) + histreader.getAskClose(i)) / 2
                            volumearray(barcount) = histreader.getVolume(i)

                            bidopenarray(barcount) = histreader.getBidOpen(i)
                            bidhigharray(barcount) = histreader.getBidHigh(i)
                            bidlowarray(barcount) = histreader.getBidLow(i)
                            bidclosearray(barcount) = histreader.getBidClose(i)
                            askopenarray(barcount) = histreader.getAskOpen(i)
                            askhigharray(barcount) = histreader.getAskHigh(i)
                            asklowarray(barcount) = histreader.getAskLow(i)
                            askclosearray(barcount) = histreader.getAskClose(i)
#Else
                                openarray(barcount) = histreader.getBidOpen(i)
                                higharray(barcount) = histreader.getBidHigh(i)
                                lowarray(barcount) = histreader.getBidLow(i)
                                closearray(barcount) = histreader.getBidClose(i)
                                volumearray(barcount) = histreader.getVolume(i)
#End If
                                barcount = barcount + 1
                            Next i
                        Else
                            ' Historical Tick by Tick data
                            For i = histreader.Count - 1 To 0 Step -1
                                datearray(barcount) = (converter.convert(histreader.getDate(i), O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST).AddMinutes(absBarInterval).ToOADate())   ' adjust date/time from start of bar timestamp to end of bar timestamp
                                closearray(barcount) = histreader.getBidClose(i)
                                volumearray(barcount) = 1.0 'CSng(histreader.getVolume(i))
                                barcount = barcount + 1
                            Next i
                        End If

                        ' reset date to least recent bar
                        nextdtTo = histreader.getDate(0)

                        ' DRW 1/23/2014 the below exit with less than fill buffer appears to not work in later releases of ForexConnect like it did in early ones?!
                        'If histreader.Count < 300 Then
                        ''MsgBox("Ending Historical at " + CStr(nextdtTo) + " because histreader.Count=" + CStr(histreader.Count) + " which is less than 300")
                        'Exit Do ' not all possible records returned, so last date reached (for instance request back to a Sunday like 10/27/2013 will end at 10/27/2013 6:31pm)
                        'End If

                        ' update percent loaded
                        percent = CInt(100 * (dtTo.ToOADate() - nextdtTo.ToOADate()) / (dtTo.ToOADate() - dtFrom.ToOADate()))
                        If percent < 100 And percent <> lastpercent Then
#If DataLogFile Then
                            LogFile("Start UpdatePercent2(" + percent.ToString + ")")
#End If
                            UpdatePercent2(percent) ' don't set to 100 because setting percent to 100 tells NST that loading of ticker and it's data is done
#If DataLogFile Then
                            LogFile("End UpdatePercent2(" + percent.ToString + ")")
#End If
                            lastpercent = percent
                            If absBarInterval = 0 Then
#If DataLogFile Then
                                LogFile("Start Windows.Forms.Application.DoEvents")
#End If
                                Windows.Forms.Application.DoEvents() 'Monitor.Wait(mEvent, 50)
#If DataLogFile Then
                                LogFile("End Windows.Forms.Application.DoEvents")
#End If
                            End If
                        End If

                        ' subtract one second from least recent bar date so that next request doesn't include current least recent bar
                        nextdtTo = DateAdd(DateInterval.Second, -1, nextdtTo)
                    Else
                        ' responseListener.Reader Is Nothing (probably no more data, because an error throws an exception below), so exit loop
                        nextdtTo = dtFrom
                    End If
                Else
                    ' responselistner.get failed (probably no more data, because an error throws an exception below), so exit loop
                    nextdtTo = dtFrom
                End If
#If DataLogFile Then
                LogFile("GetHistoricalData Loop While " + dtFrom.ToOADate().ToString + " < " + (nextdtTo.ToOADate() - 0.95 / (24.0 * 60.0 * 60.0)).ToString)
#End If
            Loop While dtFrom.ToOADate() < (nextdtTo.ToOADate() - 0.95 / (24.0 * 60.0 * 60.0))  ' DRW 3/5/2014 due to crash when dtfrom as mm/dd/yy, but nextdtTo was mm/dd/yy 12:00am (my guess is rounding error)
#If DataLogFile Then
            LogFile("Historical get data loop ended at " + CStr(nextdtTo) + " with dtFrom=" + CStr(dtFrom))
#End If

            ' fill in values from least recent date to most recent date
            DataPump_AddTickerSymbol(nextdtTo.ToOADate(), strInstrument, BarInterval, Description, Category)
            TickerUpdate(NumberTickers) = False
            TickerFxcmInterval(NumberTickers) = strTimeFrame
            TickerLastDateTime(NumberTickers) = LastBarTime
            TickerLastDateTimeCount(NumberTickers) = LastBarTimeCount
            TickerLastVolume(NumberTickers) = 0

            If absBarInterval <> 0 Then
                ' Historical bar data
                olddate = 0
                For i = barcount - 1 To 0 Step -1   ' To 1 and not 0 so that skip last bar (which is probably still in progress) and add it below in HistoricalTickBufferEnd
                    'MsgBox("Adding data point " + strInstrument + ", " + CStr(BarInterval) + ", " + CStr(CDate(Date.FromOADate(datearray(i)))) + ", " + CStr(openarray(i)) + ", " + CStr(higharray(i)) + ", " + CStr(lowarray(i)) + ", " + CStr(closearray(i)) + ", " + CStr(volumearray(i)))
                    If olddate < datearray(i) Then   ' fix for issue of FXCM (or my code?) returning same buffer twice??? resulting in duplicate data
#If FULLBIDASKDATA > 0 Then
                        DataPump_AddHistoricalBar(strInstrument, BarInterval, datearray(i), openarray(i), higharray(i), lowarray(i), closearray(i), volumearray(i), bidopenarray(i), bidhigharray(i), bidlowarray(i), bidclosearray(i), askopenarray(i), askhigharray(i), asklowarray(i), askclosearray(i))
#Else
                        DataPump_AddHistoricalBar(strInstrument, BarInterval, datearray(i), openarray(i), higharray(i), lowarray(i), closearray(i), volumearray(i))
#End If
                        olddate = datearray(i)
                    Else
                        'MsgBox("FXCM Bar Warning - The next date of " + CStr(CDate(Date.FromOADate(datearray(i)))) + " at row " + CStr(i) + " is less than or equal to the prior date of " + CStr(CDate(Date.FromOADate(olddate))))
                    End If
                Next i
            Else
                ' Historical Tick by Tick data
                olddate = 0
                For i = barcount - 1 To 0 Step -1
                    If olddate <= datearray(i) Then   ' fix for issue of FXCM (or my code?) returning same buffer twice??? resulting in duplicate data
                        DataPump_AddPriceTick(strInstrument, BarInterval, datearray(i), closearray(i), volumearray(i))
                        olddate = datearray(i)
                    Else
                        'MsgBox("FXCM Tick Warning - The next date of " + CStr(CDate(Date.FromOADate(datearray(i)))) + " at row " + CStr(i) + " is less than the prior date of " + CStr(olddate))
                    End If
                Next i
            End If

            ' Add buffered ticks and stop buffering of incoming ticks while historical data request is being processed (future ticks will be added as they arrive)
            If DataServerType = 1 Then
                DataPump_HistoricalTickBufferEnd(LastTickTime.ToOADate(), openarray(0), higharray(0), lowarray(0), closearray(0), volumearray(0), LastTickTime.ToOADate(), LastTickVolume)
            Else
                GetLatestBar(NumberTickers) ' fill in gap of new data that might have occurred since historical collection actually started
                TickerUpdate(NumberTickers) = True  ' allow timer to start updating this ticker
            End If

        Catch e As Exception
            If responselistenergetflag Then
                'LogFile("GetHistoricalData responseListener exception" + Chr(13) + Chr(13) + "Getting " + strInstrument + " with timeframe " + strTimeFrame + " and NSTBarInterval " + CStr(BarInterval) + " from " + CStr(dtFrom) + " to " + CStr(dtTo) + Chr(13) + Chr(13) + "responseListener.get(" + strInstrument + ", " + strTimeFrame + ", " + CStr(dtFrom) + "[" + CStr(CDbl(dtFrom.ToOADate())) + "], " + CStr(nextdtTo) + "[" + CStr(CDbl(nextdtTo.ToOADate())) + "], False, 15)" + Chr(13) + Chr(13) + e.ToString())
                MsgBox("GetHistoricalData responseListener exception:" + Chr(13) + Chr(13) + "Getting " + strInstrument + " with timeframe " + strTimeFrame + " and NSTBarInterval " + CStr(BarInterval) + " from " + CStr(dtFrom) + " to " + CStr(dtTo) + Chr(13) + Chr(13) + "responseListener.get(" + strInstrument + ", " + strTimeFrame + ", " + CStr(dtFrom) + "[" + CStr(CDbl(dtFrom.ToOADate())) + "], " + CStr(nextdtTo) + "[" + CStr(CDbl(nextdtTo.ToOADate())) + "], False, 15)" + Chr(13) + Chr(13) + e.ToString(), MsgBoxStyle.SystemModal)
            Else
                'LogFile("GetHistoricalData Exception: " + e.ToString())
                MsgBox("GetHistoricalData Exception:" + e.ToString(), MsgBoxStyle.SystemModal)
            End If
        End Try

        ' notify NST that data loading is done
        UpdatePercent2(100)
    End Sub

    Public Sub GetLatestBar(TickerNumber As Integer)
        Dim histreader As O2GMarketDataSnapshotResponseReader
        Dim converter As O2GTimeConverter = mSession.getTimeConverter()
        Dim ESTDateTime As Date
        Dim EstDateTimeDouble As Double
        Dim barcount As Integer
        Dim errorline As Integer = -1
        Dim abortflag As Boolean = False

        Try
            ' request most recent OHLCV bars (since fXCM tick by tick updates don't include all ticks)
            'MsgBox("START History tick request for " + TickerSymbol(j) + " " + TickerFxcmInterval(j) + " from " + CStr(TickerLastDateTime(j)))
            errorline = -3
            If (Not statusListener.Connected) Or (responseListener Is Nothing) Then
                errorline = -2
                If Not WasLoggedOn Then Exit Sub
                errorline = -1

                ' try to logon again
                If Not Logon("", "") Then Exit Sub
            End If

            errorline = 0
            If responseListener Is Nothing Then
                MsgBox("GetLatestBar - Response Listner is not set.  Aborting get latest bar", MsgBoxStyle.SystemModal)
            ElseIf statusListener.Error IsNot Nothing Then
                ' DRW 8/20/2014 attempt to get rid of system.exceptions in responselistener.get when FXCM doing weekly maintenance and NST tried to get historical data or realtime updates
                UpdatePercent2(100)  ' notify NST that data loading is done
                Exit Sub
            Else
                errorline = 1
                If responseListener.get(TickerSymbol(TickerNumber), TickerFxcmInterval(TickerNumber), TickerLastDateTime(TickerNumber), Date.FromOADate(0), False, 5) Then
                    'MsgBox("DONE - History tick request for " + TickerSymbol(j) + " " + TickerFxcmInterval(j) + " back to " + CStr(TickerLastDateTime(j)))
                    errorline = 2
                    If responseListener.Reader IsNot Nothing Then
                        histreader = responseListener.Reader
                        errorline = 3
                        If histreader.Count > 0 Then
                            'If histreader.Count > 2 Then
                            'MsgBox("PROCESS - History tick read for " + TickerSymbol(TickerNumber) + " " + TickerFxcmInterval(TickerNumber) + " back to " + CStr(TickerLastDateTime(TickerNumber)) + " gave " + CStr(histreader.Count) + " records.")
                            'End If
                            errorline = 4
                            If TickerBarInterval(TickerNumber) = 0 Then
                                errorline = 5
                                barcount = 1
                                errorline = 6
                                For k As Integer = 0 To histreader.Count - 1
                                    errorline = 7
                                    If histreader.getDate(k) > TickerLastDateTime(TickerNumber) Then 'Or (histreader.getDate(k) = TickerLastDateTime(TickerNumber) And barcount > TickerLastDateTimeCount(k)) Then
                                        errorline = 8
                                        ESTDateTime = (converter.convert(histreader.getDate(k), O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST).AddMinutes(Math.Abs(TickerBarInterval(TickerNumber))))   ' adjust date/time from start of bar timestamp to end of bar timestamp
                                        errorline = 9
                                        DataPump_AddPriceTick(TickerSymbol(TickerNumber), TickerBarInterval(TickerNumber), ESTDateTime.ToOADate(), histreader.getBidClose(k), 1.0) 'histreader.getVolume(k))
                                    End If
                                    errorline = 10
                                    barcount = barcount + 1
                                Next k
                                errorline = 11
                                TickerLastDateTime(TickerNumber) = histreader.getDate(histreader.Count - 1)
                            Else
                                errorline = 12
                                For k As Integer = 0 To histreader.Count - 1
                                    errorline = 13
                                    'If histreader.getDate(k) >= TickerLastDateTime(TickerNumber) Then
                                    If histreader.getDate(k) > TickerLastDateTime(TickerNumber) Or (histreader.getDate(k) = TickerLastDateTime(TickerNumber) And TickerLastVolume(TickerNumber) < histreader.getVolume(k)) Then
                                        errorline = 14
                                        ESTDateTime = (converter.convert(histreader.getDate(k), O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST).AddMinutes(Math.Abs(TickerBarInterval(TickerNumber))))   ' adjust date/time from start of bar timestamp to end of bar timestamp
                                        errorline = 15
#If FULLBIDASKDATA = 2 Then
                                        EstDateTimeDouble = ESTDateTime.ToOADate()   ' see if assigning to double first helps the error message user reported of "Invalid cast from Double to DateTime"
                                        DataPump_UpdateRealTimeBar(TickerSymbol(TickerNumber), TickerBarInterval(TickerNumber), EstDateTimeDouble, (histreader.getBidOpen(k) + histreader.getAskOpen(k)) / 2, histreader.getAskHigh(k), histreader.getBidLow(k), (histreader.getBidClose(k) + histreader.getAskClose(k)) / 2, histreader.getVolume(k), histreader.getBidOpen(k), histreader.getBidHigh(k), histreader.getBidLow(k), histreader.getBidClose(k), histreader.getAskOpen(k), histreader.getAskHigh(k), histreader.getAskLow(k), histreader.getAskClose(k))
#ElseIf FULLBIDASKDATA = 1 Then
                                        EstDateTimeDouble = ESTDateTime.ToOADate()   ' see if assigning to double first helps the error message user reported of "Invalid cast from Double to DateTime"
                                        DataPump_UpdateRealTimeBar(TickerSymbol(TickerNumber), TickerBarInterval(TickerNumber), EstDateTimeDouble, histreader.getBidOpen(k), histreader.getBidHigh(k), histreader.getBidLow(k), histreader.getBidClose(k), histreader.getVolume(k), histreader.getBidOpen(k), histreader.getBidHigh(k), histreader.getBidLow(k), histreader.getBidClose(k), histreader.getAskOpen(k), histreader.getAskHigh(k), histreader.getAskLow(k), histreader.getAskClose(k))
#Else
                                        'DataPump_UpdateRealTimeBar(TickerSymbol(TickerNumber), TickerBarInterval(TickerNumber), ESTDateTime.ToOADate(, histreader.getBidOpen(k), histreader.getBidHigh(k), histreader.getBidLow(k), histreader.getBidClose(k)), histreader.getVolume(k))
                                        EstDateTimeDouble = ESTDateTime.ToOADate()   ' see if assigning to double first helps the error message user reported of "Invalid cast from Double to DateTime"
                                        DataPump_UpdateRealTimeBar(TickerSymbol(TickerNumber), TickerBarInterval(TickerNumber), EstDateTimeDouble, CSng(histreader.getBidOpen(k), histreader.getBidHigh(k), histreader.getBidLow(k), histreader.getBidClose(k)), histreader.getVolume(k))
                                        'LogFile("responseListener.get(" + TickerSymbol(TickerNumber) + ", " + TickerFxcmInterval(TickerNumber) + ", " + TickerLastDateTime(TickerNumber).ToShortDateString + " " + TickerLastDateTime(TickerNumber).ToShortTimeString)
                                        'LogFile("k=" + CStr(k) + " histreader.getDate(k)=" + histreader.getDate(k).ToShortDateString + " " + histreader.getDate(k).ToShortTimeString)
                                        'LogFile("UpdateRealTimeBar " + TickerSymbol(TickerNumber) + ", " + CStr(TickerBarInterval(TickerNumber)) + ", " + ESTDateTime.ToShortDateString + " " + ESTDateTime.ToShortTimeString + ", " + CStr(CSng(histreader.getBidOpen(k))) + ", " + CStr(CSng(histreader.getBidHigh(k))) + ", " + CStr(CSng(histreader.getBidLow(k))) + ", " + CStr(CSng(histreader.getBidClose(k))) + ", " + CStr(histreader.getVolume(k)))
#End If
                                        errorline = 16
                                        TickerLastDateTime(TickerNumber) = histreader.getDate(k)
                                        TickerLastVolume(TickerNumber) = histreader.getVolume(k)
                                    End If
                                    errorline = 17
                                Next k
                            End If
                        Else
                            'MsgBox("NO DATA - History tick read for " + TickerSymbol(j) + " " + TickerFxcmInterval(j) + " back to " + CStr(TickerLastDateTime(j)) + " gave " + CStr(histreader.Count) + " records.")
                        End If
                    Else
                        'MsgBox("HISTORY READER DID NOT LOAD - History tick request for " + TickerSymbol(j) + " " + TickerFxcmInterval(j) + " back to " + CStr(TickerLastDateTime(j)))
                    End If
                Else
                    'MsgBox("FAILED - History tick request for " + TickerSymbol(j) + " " + TickerFxcmInterval(j) + " back to " + CStr(TickerLastDateTime(j)))
                End If
                errorline = 18
            End If
        Catch e As Exception
            If errorline = 15 Then
                MsgBox("Symbol=" + TickerSymbol(TickerNumber) + " BarInterval=" + CStr(TickerBarInterval(TickerNumber)) + " BarDateTime=" + ESTDateTime.ToString + Chr(13) + Chr(13) + "GetLatestBar Exception at line " + CStr(errorline) + ": " + e.ToString(), MsgBoxStyle.SystemModal)
            ElseIf InStr(e.ToString(), "no data found") > 0 Then
                ' no error message (on friday evening was getting Reason='unsupported scope', Description=no data found for instrument=null,interval=100 ...
            Else
                MsgBox("GetLatestBar Exception at line " + CStr(errorline) + ": " + e.ToString(), MsgBoxStyle.SystemModal)
            End If
        End Try
    End Sub
#Else
    Class ParamsFromLoginRules
        'Public sAccountID As String
        Public sOfferID As String
        'Public iBaseAmount As Integer
        Public dPointSize As Double
        Public dAskRate As Double
        Public dBidRate As Double
    End Class

    Public Sub GetExistingTrades(sAccountId As String, sOfferID As String, sBuySell As String, ByRef NumTrades As Integer, ByRef TradeAmounts() As Integer, ByRef TradeIds() As String)
        Dim factory As O2GResponseReaderFactory = mSession.getResponseReaderFactory
        Dim loginRules As O2GLoginRules = mSession.getLoginRules
        Dim tradesResponse As O2GResponse
        Dim index As Integer
        Dim tradedates() As Date
        Dim j As Integer

        ' Get TableResponse
        If loginRules.isTableLoadedByDefault(O2GTableType.Trades) Then
            tradesResponse = loginRules.getTableRefreshResponse(O2GTableType.Trades)
        Else
            Dim factoryreq As O2GRequestFactory = mSession.getRequestFactory()
            Dim refreshTrades As O2GRequest = factoryreq.createRefreshTableRequest(O2GTableType.Trades)
            responseListener.sendRequestAndWait(refreshTrades)
            tradesResponse = responseListener.getLastResponse()
        End If

        NumTrades = 0
        If tradesResponse IsNot Nothing Then
            Dim tradesReader As O2GTradesTableResponseReader = factory.createTradesTableReader(tradesResponse)
            If tradesReader IsNot Nothing Then
                ReDim TradeAmounts(tradesReader.Count)
                ReDim TradeIds(tradesReader.Count)
                ReDim tradedates(tradesReader.Count)
                For i As Integer = 0 To tradesReader.Count - 1
                    Dim trade As O2GTradeRow = tradesReader.getRow(i)
                    If trade.AccountID = sAccountId And trade.OfferID = sOfferID And trade.BuySell <> sBuySell Then
                        'MsgBox("Existing Trade: " + "OpenTime=" + CStr(trade.OpenTime) + "  Amount=" + CStr(trade.Amount) + Chr(13) + Chr(13) + " TradeID =" + CStr(trade.TradeID) + " OfferID=" + CStr(trade.OfferID) + " AccountID=" + CStr(trade.AccountID) + " AccountName=" + CStr(trade.AccountName) + " AccountKind=" + CStr(trade.AccountKind) + " BuySell=" + CStr(trade.BuySell) + " Commission=" + CStr(trade.Commission) + " RollInt=" + CStr(trade.RolloverInterest) + " Open=" + CStr(trade.OpenRate) + " OpenOrderID=" + CStr(trade.OpenOrderID) + " OpenOrderReqID=" + CStr(trade.OpenOrderReqID) + " RequestTXT=" + CStr(trade.OpenOrderRequestTXT) + " QuoteID=" + CStr(trade.OpenQuoteID) + " UsedMargin=" + CStr(trade.UsedMargin) + " TradeIDOrigin=" + CStr(trade.TradeIDOrigin) + " Parties=" + CStr(trade.Parties))

                        ' determine where trade should be inserted in list of other trades (order from most recent first to least recent last)
                        index = 0
                        If NumTrades > 0 Then
                            For j = NumTrades - 1 To 0 Step -1
                                If tradedates(j) > trade.OpenTime Then
                                    index = j + 1
                                    Exit For
                                End If
                            Next

                            ' move old trades forward
                            For j = NumTrades - 1 To index Step -1
                                TradeAmounts(j + 1) = TradeAmounts(j)
                                TradeIds(j + 1) = TradeIds(j)
                                tradedates(j + 1) = tradedates(j)
                            Next
                        End If

                        ' save this trade
                        NumTrades = NumTrades + 1
                        TradeAmounts(index) = trade.Amount
                        TradeIds(index) = trade.TradeID
                        tradedates(index) = trade.OpenTime
                    End If
                Next
            Else
                LogFile("No Existing Trades (reader=NULL)")
            End If
        Else
            LogFile("No Existing Trades (tradesResponse=NULL)")
        End If
    End Sub

    Public Sub CreateOrder(OrderId As String, TickerSymbol As String, ByVal quantity As Integer, NSTOrderType As Integer, NSTAction As Integer, StopPrice As Double, LimitPrice As Double)
        Dim txt As String = ""
        Dim sBuySell As String = ""
        Dim FIFOFlag As Boolean = False
        Dim NumExistingTrades As Integer = 0
        Dim ExistingTradeAmount(20) As Integer
        Dim ExistingTradeIds(20) As String
        Dim OrderAmount As Integer
        Dim sTradeId As String = ""
        Dim sizestr As String = ""
        Dim lotsize As Long
        Dim createOrderRequestCount As Long
        Dim createOrderRequestLoopFlag As Boolean
        Dim request As O2GRequest

        LogFile("CreateOrder(" + OrderId + ")")

        Dim sAccountId As String = statusListener.AccountId

        'If quantity < 1000 Then
        'LogFile("Unable to place order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is less than 1000 minimum quantity (1 lot) required by FXCM.  To avoid this message in the future, set the position sizing to more than 1000 in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.")
        'MsgBox("Unable to place order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is less than 1000 minimum quantity (1 lot) required by FXCM." + Chr(13) + Chr(13) + "To avoid this message in the future, set the position sizing to more than 1000 in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.", MsgBoxStyle.SystemModal)
        'Return
        'ElseIf quantity / 1000 <> CLng(quantity / 1000) Then
        'LogFile("Unable to place order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is not a multiple of 1000 (1 lot) as required by FXCM.  To avoid this message in the future, set 'Buy units in round lots of ' to 1000 in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.")
        'MsgBox("Unable to place order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is not a multiple of 1000 (1 lot) as required by FXCM." + Chr(13) + Chr(13) + "To avoid this message in the future, set 'Buy units in round lots of ' to 1000 in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.", MsgBoxStyle.SystemModal)
        'Return
        'End If

        Dim params As ParamsFromLoginRules = New ParamsFromLoginRules
        Dim bParamsOK As Boolean = prepareParamsFromLoginRules(params, TickerSymbol)
        If Not bParamsOK Then
            LogFile("Unable to place order for " + TickerSymbol + ".  createOrder bParams is not OK")
            MsgBox("Unable to place order for " + TickerSymbol + ".  createOrder bParams is not OK", MsgBoxStyle.SystemModal)
            Return
        End If

        Dim sOfferId As String = params.sOfferID

        Select Case NSTAction
            Case LONGENTRY_ACTION, SHORTEXIT_ACTION : sBuySell = Constants.Buy
            Case LONGEXIT_ACTION, SHORTENTRY_ACTION : sBuySell = Constants.Sell
        End Select

        ' ************************************************************************************************************************
        ' US accounts must observe FIFO. With this in mind, they cannot place stop and limit orders on 
        ' individual trades. For US accounts, Stop-Entry (SE) and Limit-Entry (LE) orders simply cancel out existing trades in the 
        ' same instrument, in the order that they were opened.   
        ' ************************************************************************************************************************
        ''Dim loginRules As O2GLoginRules = mSession.getLoginRules()
        ''Dim permissionChecker As O2GPermissionChecker = loginRules.getPermissionChecker()
        ''MsgBox("permissionChecker.canCreateMarketCloseOrder(" + CStr(TickerSymbol) + ")=" + CStr(permissionChecker.canCreateMarketCloseOrder(TickerSymbol)) + "  enabled=" + CStr(O2GPermissionStatus.PermissionEnabled) + "  hidden=" + CStr(O2GPermissionStatus.PermissionHidden) + "  disabled=" + CStr(O2GPermissionStatus.PermissionDisabled))
        ''If Not (permissionChecker.canCreateMarketCloseOrder(TickerSymbol) = O2GPermissionStatus.PermissionEnabled) Then  ' check if ticker must observe FIFO rules

        'If USAccount Then
        'FIFOFlag = True  ' set FIFOFlag
        'GetExistingTrades(sAccountId, sOfferId, sBuySell, NumExistingTrades, ExistingTradeAmount, ExistingTradeIds)  ' get existing trades so if order is lager than prior entries, then FIFO rules can be avoided by splitting it up according to size of prior entries 
        'End If

        ' Loop through placing orders until full quantity reached (in case FIFO rules require order be split into multiple orders to exit existing positions in order/quantity entered)
        Do While quantity > 0
            ' split up into multiple orders if needed to satisfy FIFO rules 
            sTradeId = ""
            If Not FIFOFlag Or NumExistingTrades = 0 Then
                ' Fill full amount (if not FIFOFlag or no existing trades) 
                OrderAmount = quantity
                'MsgBox("NOT Splitting up trade -> Amount = " + CStr(OrderAmount) + "  FIFOFlag=" + CStr(FIFOFlag) + "  NumExisting=" + CStr(NumExistingTrades))
            Else
                sTradeId = ExistingTradeIds(NumExistingTrades - 1)   ' set TradeId of First-In Trade that is being closed (??? or partially closed if allowed ???)
                If quantity < ExistingTradeAmount(NumExistingTrades - 1) Then
                    ' Fill full amount (quantity less than first existing trade) 
                    OrderAmount = quantity
                    'MsgBox("NOT Splitting up trade -> Amount = " + CStr(OrderAmount) + "  Amount of FIFO compliance trade=" + CStr(ExistingTradeAmount(NumExistingTrades - 1)))
                Else
                    ' Split up trade so that it is not larger than first trade
                    OrderAmount = ExistingTradeAmount(NumExistingTrades - 1)
                    NumExistingTrades = NumExistingTrades - 1
                    'MsgBox("Splitting up trade -> First amount = " + CStr(OrderAmount))
                End If
            End If
            quantity = quantity - OrderAmount

            txt = ""
            Dim factory As O2GRequestFactory = mSession.getRequestFactory()
            Dim valuemap As O2GValueMap = factory.createValueMap()
            valuemap.setString(O2GRequestParamsEnum.Command, Constants.Commands.CreateOrder)
            txt = txt + "AccountID=" + sAccountId + ", "
            valuemap.setString(O2GRequestParamsEnum.AccountID, sAccountId)   ' The identifier of the account the order should be placed for.
            txt = txt + "OfferID=" + params.sOfferID + ", "
            valuemap.setString(O2GRequestParamsEnum.OfferID, sOfferId)       ' The identifier of the instrument the order should be placed for.
            txt = txt + "BuySell=" + sBuySell + ", "
            valuemap.setString(O2GRequestParamsEnum.BuySell, sBuySell)

            If sTradeId = "" Then
                Select Case NSTOrderType
                    Case MARKET_ORDER
                        txt = txt + "OrderType=TrueMarketOpen, "
                        valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.TrueMarketOpen)
                    Case STOP_ORDER
                        txt = txt + "OrderType=StopEntry, "
                        valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.StopEntry)
                    Case LIMIT_ORDER
                        txt = txt + "OrderType=LimitEntry, "
                        valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.LimitEntry)
                End Select
            Else
                Select Case NSTOrderType
                    Case MARKET_ORDER
                        txt = txt + "OrderType=TrueMarketClose, "
                        valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.MarketClose) 'TrueMarketClose)
                    Case STOP_ORDER
                        txt = txt + "OrderType=Stop, "
                        valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.Stop)
                    Case LIMIT_ORDER
                        txt = txt + "OrderType=Limit, "
                        valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.Limit)
                End Select

                txt = txt + "TradeId=" + sTradeId + ", "
                valuemap.setString(O2GRequestParamsEnum.TradeID, sTradeId)   ' The identifier of the trade to be closed (do not fill for Net amount order).

                If (sBuySell.Equals(Constants.Buy)) Then
                    txt = txt + "Rate=dAskRate=" + CStr(params.dAskRate) + ", "
                    valuemap.setDouble(O2GRequestParamsEnum.Rate, params.dAskRate)   ' The identifier of the trade to be closed (do not fill for Net amount order).
                Else
                    txt = txt + "Rate=dBidRate=" + CStr(params.dBidRate) + ", "
                    valuemap.setDouble(O2GRequestParamsEnum.Rate, params.dBidRate)   ' The identifier of the trade to be closed (do not fill for Net amount order).
                End If
            End If
            'Else
            ' non-FIFO accounts

            ' ??????????????????
            ' For closing trades, does it need:       
            ' valuemap.setString(O2GRequestParamsEnum.TradeID, sTradeID)   ' The identifier of the trade to be closed (do not fill for Net amount order).
            ' ??????????????????

            'Select Case NSTOrderType
            '   Case MARKET_ORDER
            '       Select Case NSTAction
            '           Case LONGENTRY_ACTION, SHORTENTRY_ACTION : valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.TrueMarketOpen)
            '           Case LONGEXIT_ACTION, SHORTEXIT_ACTION : valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.TrueMarketClose)
            '       End Select
            '   Case STOP_ORDER
            '       Select Case NSTAction
            '           Case LONGENTRY_ACTION, SHORTENTRY_ACTION : valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.StopEntry)
            '           Case LONGEXIT_ACTION, SHORTEXIT_ACTION : valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.Stop)
            '       End Select
            '   Case LIMIT_ORDER
            '       Select Case NSTAction
            '           Case LONGENTRY_ACTION, SHORTENTRY_ACTION : valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.LimitEntry)
            '           Case LONGEXIT_ACTION, SHORTEXIT_ACTION : valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.Limit)
            '       End Select
            'End Select
            'End If

            Select Case NSTOrderType
                Case STOP_ORDER
                    Select Case NSTAction
                        Case LONGENTRY_ACTION, SHORTEXIT_ACTION
                            ''ElseIf StopPrice < params.dAskRate + params.dPointSize Then  ''valuemap.setString(O2GRequestParamsEnum.Rate, CStr(params.dAskRate + params.dPointSize))
                            txt = txt + "Rate=" + CStr(StopPrice) + ", "
                            valuemap.setDouble(O2GRequestParamsEnum.Rate, StopPrice)
                        Case SHORTENTRY_ACTION, LONGEXIT_ACTION
                            'If StopPrice >= params.dBidRate Then
                            '' turn into a market order to execute immediately
                            'valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.TrueMarketOpen)
                            ''ElseIf StopPrice > params.dBidRate - params.dPointSize Then                       ''    valuemap.setString(O2GRequestParamsEnum.Rate, CStr(params.dBidRate - params.dPointSize))
                            ''    'MsgBox("Short Stop at " + CStr(StopPrice) + " converting to " + CStr(params.dBidRate - params.dPointSize) + "[ask=" + CStr(params.dAskRate) + " bid=" + CStr(params.dBidRate) + " pointsize=" + CStr(params.dPointSize) + "]")
                            'Else
                            txt = txt + "Rate=" + CStr(StopPrice) + ", "
                            valuemap.setDouble(O2GRequestParamsEnum.Rate, StopPrice)
                            'End If
                    End Select
                Case LIMIT_ORDER
                    'valuemap.setString(O2GRequestParamsEnum.RateLimit, CStr(LimitPrice))
                    Select Case NSTAction
                        Case LONGENTRY_ACTION, SHORTEXIT_ACTION
                            'If StopPrice > params.dAskRate + params.dPointSize Then
                            If False And StopPrice > params.dBidRate Then
                                txt = txt + "Rate=dBidRate=" + CStr(params.dBidRate) + ", "
                                valuemap.setDouble(O2GRequestParamsEnum.Rate, params.dBidRate) '+ params.dPointSize))
                            Else
                                txt = txt + "Rate=" + CStr(LimitPrice) + ", "
                                valuemap.setDouble(O2GRequestParamsEnum.Rate, LimitPrice)
                            End If
                        Case SHORTENTRY_ACTION, LONGEXIT_ACTION
                            'If StopPrice > params.dBidRate - params.dPointSize Then
                            If False And StopPrice < params.dAskRate Then
                                txt = txt + "Rate=dAskRate=" + CStr(params.dAskRate) + ", "
                                valuemap.setDouble(O2GRequestParamsEnum.Rate, params.dAskRate) ' - params.dPointSize))
                            Else
                                txt = txt + "Rate=" + CStr(LimitPrice) + ", "
                                valuemap.setDouble(O2GRequestParamsEnum.Rate, LimitPrice)
                            End If
                    End Select
                Case STOPLIMIT_ORDER
                    LogFile("Unable to place order for " + TickerSymbol + ".  StopLimit Orders not supported.")
                    MsgBox("Unable to place order for " + TickerSymbol + ".  StopLimit Orders not supported.", MsgBoxStyle.SystemModal)
                    Return
                Case MARKETCLOSE_ORDER
                    LogFile("Unable to place order for " + TickerSymbol + ".  Market Close Orders not supported.")
                    MsgBox("Unable to place order for " + TickerSymbol + ".  Market Close Orders not supported.", MsgBoxStyle.SystemModal)
                    Return
            End Select
            txt = txt + "Amount=" + CStr(OrderAmount) + ", "
            valuemap.setInt(O2GRequestParamsEnum.Amount, OrderAmount)   ' params.iBaseAmount * 2                ' The quantity of the instrument to be bought or sold.
            txt = txt + "CustomID=" + OrderId + ", "
            valuemap.setString(O2GRequestParamsEnum.CustomID, OrderId)      ' The custom identifier of the order.

            LogFile("factory.createOrderRequest(" + txt + ")")
            'MsgBox("factory.createOrderRequest(" + txt + ")")

            'Dim request As O2GRequest = factory.createOrderRequest(valuemap)
            ' DRW 7/21/2015 added multiple create order requests to see if it fixes the issue of "Instrument not available for trading" showing up periodically during market hours???
            createOrderRequestCount = 0
            Do
                request = factory.createOrderRequest(valuemap)
                createOrderRequestLoopFlag = False
                If request Is Nothing Then
                    If InStr(factory.getLastError(), "Instrument is not available for trading") > 0 Then
                        createOrderRequestCount += 1
                        If createOrderRequestCount < 20 Then
                            createOrderRequestLoopFlag = True
                            Threading.Thread.Sleep(500) ' 500 milliseconds = 0.5 seconds
                        End If
                    End If
                End If
            Loop While createOrderRequestLoopFlag

            If request IsNot Nothing Then
                Dim ret As String = responseListener.sendRequestAndWait(request)
                If ret <> "" Then
                    If (NSTOrderType = STOP_ORDER Or NSTOrderType = LIMIT_ORDER) And InStr(ret, "19001") > 0 And InStr(ret, "Incorrect price") > 0 Then
                        ' stop or limit price is on wrong side of bid/ask, so turn into a market order to execute immediately
                        valuemap.setString(O2GRequestParamsEnum.OrderType, Constants.Orders.TrueMarketOpen)
                        ret = responseListener.sendRequestAndWait(factory.createOrderRequest(valuemap))
                        LogFile("Turned Stop/Limit that was above/below bid/ask into market order")
                    End If
                    If ret <> "" Then
                        If InStr(ret, "HTTP receive response failed") > 0 Then
                            LogFile("Error placing order (HTTP receive response failed):  NeuroShell Trader is not connected with the FXCM server and is unable to place an order.  Please make sure that you still have a live Internet connection.")
                            MsgBox("Error placing order (HTTP receive response failed)" + Chr(13) + Chr(13) + "NeuroShell Trader is not connected with the FXCM server and is unable to place an order.  Please make sure that you still have a live Internet connection.", MsgBoxStyle.SystemModal)
                        ElseIf InStr(ret, "Quantity fraction size violated:") > 0 Then
                            'MsgBox("Parsed string = '" + Right(ret, Len(ret) - InStr(ret, "violated:") - 9) + "'")
                            Try
                                lotsize = CLng(Right(ret, Len(ret) - InStr(ret, "violated:") - 9))
                                If quantity < lotsize Then
                                    LogFile("Quantity error placing order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is less than " + lotsize.ToString + " minimum quantity (1 lot) required by FXCM.  To avoid this message in the future, set the position sizing to more than " + lotsize.ToString + " in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.")
                                    MsgBox("Quantity error placing order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is less than " + lotsize.ToString + " minimum quantity (1 lot) required by FXCM." + Chr(13) + Chr(13) + "To avoid this message in the future, set the position sizing to more than " + lotsize.ToString + " in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.", MsgBoxStyle.SystemModal)
                                ElseIf quantity / lotsize <> CLng(quantity / lotsize) Then
                                    LogFile("Quantity error placing order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is not a multiple of " + lotsize.ToString + " (1 lot) as required by FXCM.  To avoid this message in the future, set 'Buy units in round lots of ' to " + lotsize.ToString + " in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.")
                                    MsgBox("Quantity error placing order for " + TickerSymbol + ".  Order quantity of " + CStr(quantity) + " is not a multiple of " + lotsize.ToString + " (1 lot) as required by FXCM." + Chr(13) + Chr(13) + "To avoid this message in the future, set 'Buy units in round lots of ' to " + lotsize.ToString + " in the Size tab of NeuroShell Trader's 'Trading Strategy Parameters' dialog.", MsgBoxStyle.SystemModal)
                                End If
                            Catch e As Exception
                                LogFile("########## Quantity error placing order for " + TickerSymbol + ": " + ret)
                                MsgBox("Quantity error placing order for " + TickerSymbol + ": " + Chr(13) + Chr(13) + ret, MsgBoxStyle.SystemModal)
                            End Try
                        Else
                            LogFile("########## Error placing order for " + TickerSymbol + ": " + ret)
                            MsgBox("Error placing order for " + TickerSymbol + ": " + Chr(13) + Chr(13) + ret, MsgBoxStyle.SystemModal)
                        End If
                    End If
                End If
            Else
                LogFile("########## Error creating order for " + TickerSymbol + ": " + factory.getLastError())
                MsgBox("Error placing order for " + TickerSymbol + ": " + Chr(13) + Chr(13) + factory.getLastError(), MsgBoxStyle.SystemModal)
            End If
            'MsgBox("Limit at " + CStr(LimitPrice) + "[ask=" + CStr(params.dAskRate) + " bid=" + CStr(params.dBidRate) + " pointsize=" + CStr(params.dPointSize) + "]")
        Loop
    End Sub

    Public Sub DeleteOrder(ByVal sOrderID As String)
        LogFile("DeleteOrder(" + sOrderID + ")")

        Dim sAccountId As String = statusListener.AccountId

        Dim factory As O2GRequestFactory = mSession.getRequestFactory()
        If factory Is Nothing Then Return

        Dim valuemap As O2GValueMap = factory.createValueMap()
        valuemap.setString(O2GRequestParamsEnum.Command, Constants.Commands.DeleteOrder)
        valuemap.setString(O2GRequestParamsEnum.OrderID, sOrderID)
        valuemap.setString(O2GRequestParamsEnum.AccountID, statusListener.AccountId)
        Dim request As O2GRequest = factory.createOrderRequest(valuemap)
        If request IsNot Nothing Then
            Dim ret As String = responseListener.sendRequestAndWait(request)
            If ret <> "" Then
                LogFile("########## Error deleting order " + sOrderID + ": " + ret)
                If InStr(ret, "Cannot find order") > 0 Then
                    ' Can't find order so send order cancel notification
                    TradePump_OrderCanceled(sOrderID)
                Else
                    MsgBox("Error deleting order " + sOrderID + ": " + ret, MsgBoxStyle.SystemModal)
                End If
            End If
        Else
            LogFile("########## Factory Error deleting order " + sOrderID + ": " + factory.getLastError())
            MsgBox("Factory Error deleting order " + sOrderID + ": " + Chr(13) + Chr(13) + factory.getLastError(), MsgBoxStyle.SystemModal)
        End If
    End Sub

    Public Sub editOrder(sOrderID As String, dRate As Double)
        LogFile("editOrder(" + sOrderID + "," + Format$(dRate) + ")")

        Dim factory As O2GRequestFactory = mSession.getRequestFactory()
        If factory Is Nothing Then Return

        Dim valuemap As O2GValueMap = factory.createValueMap()
        valuemap.setString(O2GRequestParamsEnum.Command, Constants.Commands.EditOrder)
        valuemap.setString(O2GRequestParamsEnum.OrderID, sOrderID)
        valuemap.setString(O2GRequestParamsEnum.AccountID, statusListener.AccountId)
        valuemap.setDouble(O2GRequestParamsEnum.Rate, dRate)
        'valuemap.setInt(O2GRequestParamsEnum.Amount, iAmount)
        'valuemap.setString(O2GRequestParamsEnum.CustomID, sOrderID)

        Dim request As O2GRequest = factory.createOrderRequest(valuemap)
        If request IsNot Nothing Then
            mSession.sendRequest(request)
            Dim ret As String = responseListener.sendRequestAndWait(request)
            If ret <> "" Then
                LogFile("########## Error editing order " + sOrderID + " to a rate of " + CStr(dRate) + ": " + ret)
                If InStr(ret, "Cannot find order") = 0 Then MsgBox("Error editing order " + sOrderID + " to a rate of " + CStr(dRate) + ": " + ret, MsgBoxStyle.SystemModal)
            End If
        Else
            LogFile("########## Factory Error editing order " + sOrderID + " to a rate of " + CStr(dRate) + ": " + factory.getLastError())
            MsgBox("Factory Error editing order " + sOrderID + " to a rate of " + CStr(dRate) + ": " + Chr(13) + Chr(13) + factory.getLastError(), MsgBoxStyle.SystemModal)
        End If
    End Sub

    'Public Function xxxGetAccountId() As String
    '    If AccountID = "" Then
    '' get first account from login
    'Dim loginRules As O2GLoginRules = mSession.getLoginRules
    '        If loginRules IsNot Nothing Then
    'Dim factory As O2GResponseReaderFactory = mSession.getResponseReaderFactory
    'Dim accountResponse As O2GResponse = loginRules.getTableRefreshResponse(O2GTableType.Accounts)
    'Dim accountsReader As O2GAccountsTableResponseReader = factory.createAccountsTableReader(accountResponse)
    'Dim account As O2GAccountRow = accountsReader.getRow(0)
    '
    '                AccountID = account.AccountID
    '            End If
    '        End If
    '        Return AccountID
    '    End Function

    Private Function prepareParamsFromLoginRules(ByRef params As ParamsFromLoginRules, TickerSymbol As String) As Boolean
        Dim bOK As Boolean = False
        Dim factory As O2GResponseReaderFactory = mSession.getResponseReaderFactory
        If factory IsNot Nothing Then
            Dim loginRules As O2GLoginRules = mSession.getLoginRules
            If loginRules IsNot Nothing Then
                ' get base amount
                params.sOfferID = ""
                params.dAskRate = 0
                params.dBidRate = 0
                params.dPointSize = 0

                ' Get offers for EUR/USD
                Dim offersResponse As O2GResponse = loginRules.getTableRefreshResponse(O2GTableType.Offers)
                If offersResponse IsNot Nothing Then
                    Dim offersReader As O2GOffersTableResponseReader = factory.createOffersTableReader(offersResponse)
                    If offersReader IsNot Nothing Then
                        Dim i As Integer = 0
                        Do While (i < offersReader.Count)
                            Dim offer As O2GOfferRow = offersReader.getRow(i)
                            If offer.Instrument.Equals(TickerSymbol) Then
                                params.sOfferID = offer.OfferID
                                params.dAskRate = offer.Ask
                                params.dBidRate = offer.Bid
                                params.dPointSize = offer.PointSize
                                bOK = True
                                Exit Do
                            End If
                            i = (i + 1)
                        Loop
                    End If
                End If
            End If
        End If

        Return bOK
    End Function
#End If
End Class

Friend Class ResponseListener
    Implements fxcore2.IO2GResponseListener
    Private mSession As O2GSession
    Private mEvent As New Object()
    Private mError As String
    Private mComplete As String
    Private mRequest As String
    Private mReader As O2GMarketDataSnapshotResponseReader
    Private LastResponse As O2GResponse

    Private offercount As Long = 0

    Public ReadOnly Property Reader() As O2GMarketDataSnapshotResponseReader
        Get
            Return mReader
        End Get
    End Property

    Public Sub New(ByVal session As O2GSession)
        mSession = session
    End Sub

#If DataPump Then
    Public Function [get](ByVal instrument As String, ByVal tf As String, ByVal [from] As Date, ByVal [to] As Date, msgflag As Boolean, timeoutseconds As Integer) As Boolean
        Dim tfo As O2GTimeframe
        Dim factory As O2GRequestFactory = mSession.getRequestFactory()
        Dim timeframes As O2GTimeframeCollection = factory.Timeframes
        Dim loopstart As DateTime
        Dim loopcount As Long

        mReader = Nothing
        If msgflag Then MsgBox("response get #1")
        tfo = timeframes(tf)
        If tfo Is Nothing Then
            Throw New Exception("ResponseListener: time frame is incorrect")
            [get] = False
            Exit Function
        End If
        If msgflag Then MsgBox("response get #2")
        Dim request As O2GRequest = factory.createMarketDataSnapshotRequestInstrument(instrument, tfo, 1000) '300)
        If request Is Nothing Then
            [get] = False
            Exit Function
        End If
        If msgflag Then MsgBox("response get #3")
        factory.fillMarketDataSnapshotRequestTime(request, [from], [to], False)
        mError = Nothing
        mReader = Nothing
        mRequest = request.RequestID

        If msgflag Then MsgBox("response get #4")
        mSession.subscribeResponse(Me)

        Try
            If msgflag Then MsgBox("response get #5")
            mSession.sendRequest(request)

            loopstart = DateTime.Now
            loopcount = 0
            Do
                'LogFile("response get  LoopStart=" + loopstart.ToString + "  Now=" + DateTime.Now.ToString + "  diff=" + (DateTime.Now - loopstart).ToString + "  > timeout=" + TimeSpan.FromSeconds(timeoutseconds).ToString)
                ' exit if inside loop waiting for response for more than timeoutseconds
                If DateTime.Now - loopstart > TimeSpan.FromSeconds(timeoutseconds) Then
                    [get] = False
                    'LogFile("Response Get >> Timeout")
                    Exit Function
                End If

                If msgflag Then MsgBox("response get #6")
                SyncLock mEvent
                    'Monitor.Wait(mEvent, 250)
                    'Windows.Forms.Application.DoEvents()   ' allows percent bar to work better (especially percent bar for when loading data to data pump)
                    If loopcount = 0 Then
                        Windows.Forms.Application.DoEvents()   ' allows percent bar to work better (especially percent bar for when loading data to data pump)
                    Else
                        Monitor.Wait(mEvent, 10)
                    End If
                End SyncLock
                loopcount = loopcount + 1
                If msgflag Then MsgBox("response get #7")
                If mError Is Nothing AndAlso mReader Is Nothing Then
                    Continue Do
                End If
                If msgflag Then MsgBox("response get #8")
                If mError IsNot Nothing Then
                    If InStr(mError, "No data found for") = 0 Then   ' skip throwing error message "Reason='unsupported scope', Description=No data for symbolID=xx, interval=xxx, startTimeSatemp=xxx, endTimeStamp=xxx!" as this appears to occur when requesting data across a timespan for which there is no data (for instance start request date on a market closed date, etc.)
                        Throw New Exception("ResponseListener: " & mError)  ' exception caught by Try in get historical, etc.
                    End If
                    'LogFile("Response Get >> Error: " + mError)
                    [get] = False
                    Exit Function
                End If
                'LogFile("Response Get >> Finished" + mError)
                Exit Do
            Loop
        Finally
            mSession.unsubscribeResponse(Me)
        End Try
        If msgflag Then MsgBox("response get #9")
        [get] = True
    End Function

    Public Sub onRequestCompleted(ByVal requestID As String, ByVal response As O2GResponse) Implements fxcore2.IO2GResponseListener.onRequestCompleted
        If response.Type = fxcore2.O2GResponseType.GetOffers Then
            'MsgBox("onRequestCompleted printOffers")
            'FXCM.printOffers(response, "onRequestCompleted response.Type = fxcore2.O2GResponseType.GetOffers")
        ElseIf requestID = mRequest Then
            'MsgBox("onRequestCompleted requestID = mRequest")
            If response.Type <> fxcore2.O2GResponseType.MarketDataSnapshot Then
                'MsgBox("onRequestCompleted Incorrect response")
                mError = "Incorrect response"
            Else
                'MsgBox("onRequestCompleted mReader =")
                Dim factory As O2GResponseReaderFactory = mSession.getResponseReaderFactory()
                mReader = factory.createMarketDataSnapshotReader(response)
            End If

            SyncLock mEvent
                Monitor.PulseAll(mEvent)
            End SyncLock
        Else
            'MsgBox("onRequestCompleted else")
        End If
    End Sub

    Public Sub onRequestFailed(ByVal request As String, ByVal [error] As String) Implements fxcore2.IO2GResponseListener.onRequestFailed
        If request = mRequest Then   ' NOTE:  If test for = mrequest then stop orders with bad price didn't get message?!
            mError = [error]
            'MsgBox("ResponseListener Error: " + Chr(34) + [error])
            SyncLock mEvent
                Monitor.PulseAll(mEvent)
            End SyncLock
        End If
    End Sub
#Else
    Public Function sendRequestAndWait(request As O2GRequest) As String
        ' Places a request and then waits for Completion or Failure (and returns error string if failure)

        LogFile("sendRequestAndWait(request)")
        mError = Nothing
        mComplete = Nothing
        LastResponse = Nothing
        mRequest = request.RequestID
        sendRequestAndWait = ""
        Try
            mSession.sendRequest(request)
            Do
                SyncLock mEvent
                    Monitor.Wait(mEvent, 10)
                End SyncLock
            Loop While mError Is Nothing AndAlso mComplete Is Nothing
            If mError IsNot Nothing Then
                sendRequestAndWait = mError
            End If
        Catch e As Exception
            LogFile("########## sendRequestAndWait Exception: " + e.ToString())
            MsgBox("sendRequestAndWait Exception: " + e.ToString(), MsgBoxStyle.SystemModal)
        End Try
    End Function

    Public ReadOnly Property getLastResponse() As O2GResponse
        Get
            Return LastResponse
        End Get
    End Property

    Public Sub onRequestCompleted(ByVal requestID As String, ByVal response As O2GResponse) Implements fxcore2.IO2GResponseListener.onRequestCompleted
        If requestID = mRequest Then
            LastResponse = response
            mComplete = "Complete"

            SyncLock mEvent
                Monitor.PulseAll(mEvent)
            End SyncLock
        Else
            LogFile("onRequestCompleted else: requestid = " + requestID + "  mRequest = " + mRequest)
            'MsgBox("onRequestCompleted else")
        End If
    End Sub

    Public Sub onRequestFailed(ByVal request As String, ByVal [error] As String) Implements fxcore2.IO2GResponseListener.onRequestFailed
        If request = mRequest Then   ' NOTE:  If test for = mrequest then stop orders with bad price didn't get message?!
            mError = [error]
            SyncLock mEvent
                Monitor.PulseAll(mEvent)
            End SyncLock
        Else
            LogFile("########## ResponseListener onRequestFailed else Error: " + Chr(34) + [error])
            MsgBox("ResponseListener onRequestFailed else Error: " + Chr(34) + [error], MsgBoxStyle.SystemModal)
        End If
    End Sub
#End If

    Public Sub onTablesUpdates(ByVal response As O2GResponse) Implements fxcore2.IO2GResponseListener.onTablesUpdates
        Dim factory As O2GResponseReaderFactory = mSession.getResponseReaderFactory()
        If factory Is Nothing Then Return

        Dim updatesReader As O2GTablesUpdatesReader = factory.createTablesUpdatesReader(response)
        If updatesReader Is Nothing Then Return

        For i As Integer = 0 To updatesReader.Count - 1
            updatesReader.GetType()

            Select Case updatesReader.getUpdateTable(i)
                Case O2GTableType.Accounts : processAccount(updatesReader.getAccountRow(i))
                Case O2GTableType.Offers : processOffer(updatesReader.getOfferRow(i))
#If Not DataPump Then
                Case O2GTableType.Orders : processOrder(updatesReader.getOrderRow(i))
                    'Case O2GTable.Trades : processTrade(updatesReader.getTradeRow(i))
                    'Case O2GTable.ClosedTrades : processClosedTrade(updatesReader.getClosedTradeRow(i))
#End If
                Case O2GTableType.Messages : processMsgBox(updatesReader.getMessageRow(i))
                Case O2GTableType.TableUnknown : Exit Select
                Case Else : Exit Select
            End Select
        Next
    End Sub

    Private Sub processAccount(account As O2GAccountRow)
#If Not DataPump Then
        LogFile("processAccount: " + "ResponseListener processAccount -> AccountID=" + CStr(account.AccountID) + " AccountName=" + CStr(account.AccountName) + " AccountKind=" + CStr(account.AccountKind) + " AmountLimit=" + CStr(account.AmountLimit) + " Balance=" + CStr(account.Balance) + " NonTradeEquity=" + CStr(account.NonTradeEquity) + " M2MEquity=" + CStr(account.M2MEquity) + " UsedMargin=" + CStr(account.UsedMargin) + " UsedMargin3=" + CStr(account.UsedMargin3) + " MarginCallFlag=" + CStr(account.MarginCallFlag) + " LastMarginCallDate=" + CStr(account.LastMarginCallDate) + " MaintenanceType=" + CStr(account.MaintenanceType) + " AmountLimit=" + CStr(account.AmountLimit) + " MaintenanceFlag=" + CStr(account.MaintenanceFlag) + " BaseUnitSize=" + CStr(account.BaseUnitSize) + " LevarageProfileID=" + CStr(account.LeverageProfileID) + " ManagerAccountID=" + CStr(account.ManagerAccountID))
#End If
        'ValidateAccount(account.Balance)
        FXCM.AccountBalance = account.Balance
        FXCM.USAccount = Not (account.MaintenanceType = "Y")
    End Sub

    Private Sub processOffer(row As O2GOfferRow)
        If offercount < 4 Then
            'MsgBox("Instrument=" + CStr(row.Instrument) + " OfferID=" + CStr(row.OfferID) + " Bid=" + CStr(row.Bid) + " Ask=" + CStr(row.Ask) + " Low=" + CStr(row.Low) + " High=" + CStr(row.High) + " Volume=" + CStr(row.Volume) + " QuoteID=" + CStr(row.QuoteID) + " Time=" + CStr(row.Time) + " BidTradable=" + CStr(row.BidTradable) + " AskTradable=" + CStr(row.AskTradable) + " ContractCurreny=" + CStr(row.ContractCurrency) + " Digits=" + CStr(row.Digits) + " PointSize=" + CStr(row.PointSize) + " SubscriptionStatus=" + CStr(row.SubscriptionStatus) + " TradingStatus=" + CStr(row.TradingStatus) + " InstrumentType=" + CStr(row.InstrumentType) + " ContractMultiplier=" + CStr(row.ContractMultiplier) + " ValueDate=" + CStr(row.ValueDate))
            offercount = offercount + 1
        End If

        Dim ticker As String
        Dim converter As O2GTimeConverter = mSession.getTimeConverter()
        Dim ESTDateTime As Date

        ' look for symbol and bar interval matches in data pump
        ticker = row.Instrument
        For j As Integer = 1 To NumberTickers
            ' check for symbol and bar interval match
            If TickerSymbol(j) = ticker Then
                If DataServerType = 1 Then
                    ESTDateTime = converter.convert(row.Time, O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST)

                    'MsgBox("LastHistBar=" + CStr(TickerLastDateTime(NumberTickers)) + "  MostRecentTick=" + CStr(ESTDateTime))
                    If row.Volume > TickerLastVolume(j) Then
                        DataPump_NewPriceTick(row.Instrument, ESTDateTime.ToOADate(), row.Bid, row.Volume - TickerLastVolume(j))
                    Else
                        DataPump_NewPriceTick(row.Instrument, ESTDateTime.ToOADate(), row.Bid, row.Volume)
                    End If
                    TickerLastVolume(j) = row.Volume
                Else
                    TickerUpdate(j) = True
                    'RealTimeTicksTimer.Interval = 1   ' cause update timer to fire immediately (outside of this thread or something because it seems to hang realtime updates?!)
                    'MsgBox(ticker + " has new data")
                End If
#If DataPump Then
                LogFile("processOffer " + ticker + ", " + CStr(TickerBarInterval(j)) + ", " + ESTDateTime.ToShortDateString + " " + ESTDateTime.ToShortTimeString + ", " + CStr(row.Bid) + ", " + CStr(row.Volume))
#End If
            End If
            'MsgBox("Offer #" + CStr(i) + " OfferId=" + CStr(row.OfferID) + " Instrument=" + CStr(row.Instrument) + " Time=" + CStr(row.Time) + " bid=" + CStr(row.Bid) + " ask=" + CStr(row.Ask) + " volume=" + CStr(row.Volume) + " ValueDate=" + CStr(row.ValueDate) + " Low=" + CStr(row.Low) + " High=" + CStr(row.High))
        Next j

#If False Then
        Dim ticker As String
        Dim converter As O2GTimeConverter = mSession.getTimeConverter()
        Dim ESTDateTime As Date

        ' look for symbol and bar interval matches in data pump
        ticker = row.Instrument
        For j As Integer = 1 To NumberTickers
            ' check for symbol and bar interval match
            If TickerSymbol(j) = ticker Then
                If DataServerType = 1 Then
                    ESTDateTime = converter.convert(row.Time, O2GTimeConverterTimeZone.UTC, O2GTimeConverterTimeZone.EST)

                    'MsgBox("LastHistBar=" + CStr(TickerLastDateTime(NumberTickers)) + "  MostRecentTick=" + CStr(ESTDateTime))
                    If row.Volume > TickerLastVolume(j) Then
                        DataPump_NewPriceTick(row.Instrument, ESTDateTime.ToOADate(, row.Bid, row.Volume - TickerLastVolume(j)))
                    Else
                        DataPump_NewPriceTick(row.Instrument, ESTDateTime.ToOADate(, row.Bid, row.Volume))
                    End If
                    TickerLastVolume(j) = row.Volume
                Else
                    TickerUpdate(j) = True
                End If
            End If
            'MsgBox("Offer #" + CStr(i) + " OfferId=" + CStr(row.OfferID) + " Instrument=" + CStr(row.Instrument) + " Time=" + CStr(row.Time) + " bid=" + CStr(row.Bid) + " ask=" + CStr(row.Ask) + " volume=" + CStr(row.Volume) + " ValueDate=" + CStr(row.ValueDate) + " Low=" + CStr(row.Low) + " High=" + CStr(row.High))
        Next j
#End If
    End Sub

#If Not DataPump Then
    Private Sub processOrder(order As O2GOrderRow)
        Dim statusstring As String

        Select Case order.Status
            Case "W" : statusstring = "Waiting"
            Case "P" : statusstring = "In process"
            Case "I" : statusstring = "Dealer intervention"
            Case "Q" : statusstring = "Requoted"
            Case "U" : statusstring = "Pending calculated"
            Case "E" : statusstring = "Executing"
            Case "S" : statusstring = "Pending Canceled"
            Case "C" : statusstring = "Canceled"
            Case "R" : statusstring = "ejected"
            Case "T" : statusstring = "Expired"
            Case "F" : statusstring = "Executed"
            Case Else : statusstring = "Unknown Order Status (" + order.Status + ")"
        End Select

        LogFile("   processOrder1: " + "Status=" + statusstring + " (" + order.Status + ")   RequestTXT=" + CStr(order.RequestTXT) + "  FilledAmount=" + CStr(order.FilledAmount) + "  ExecutionRate=" + CStr(order.ExecutionRate) + "OrderID=" + CStr(order.OrderID) + " OfferID=" + CStr(order.OfferID) + " TradeID=" + CStr(order.TradeID) + " AccountID=" + CStr(order.AccountID) + " AccountName=" + CStr(order.AccountName) + " AccountKind=" + CStr(order.AccountKind) + " Amount=" + CStr(order.Amount) + " BuySell=" + CStr(order.BuySell) + " Rate=" + CStr(order.Rate) + " RateMin=" + CStr(order.RateMin) + " RateMax=" + CStr(order.RateMax) + " ExecutionRate=" + CStr(order.ExecutionRate) + " TimeInForce=" + CStr(order.TimeInForce) + " LifeTime=" + CStr(order.Lifetime) + " Status=" + CStr(order.Status) + " StatusTime=" + CStr(order.StatusTime) + " Type=" + CStr(order.Type) + " NetQuantity=" + CStr(order.NetQuantity) + " TrailStep=" + CStr(order.TrailStep) + " TrailRate=" + CStr(order.TrailRate) + " PegType=" + CStr(order.PegType) + " PegOffset=" + CStr(order.PegOffset) + " ContingentOrderID=" + CStr(order.ContingentOrderID) + " WorkingIndicator=" + CStr(order.WorkingIndicator) + " ContingencyType=" + CStr(order.ContingencyType) + " PrimaryID=" + CStr(order.PrimaryID) + " OriginAmount=" + CStr(order.OriginAmount) + " FilledAmount=" + CStr(order.FilledAmount) + " RequestID=" + CStr(order.RequestID) + " RequestTXT=" + CStr(order.RequestTXT) + " ExpireDate=" + CStr(order.ExpireDate) + " ValueDate=" + CStr(order.ValueDate) + " Parties=" + CStr(order.Parties))

        'If order.Status = "P" Or order.Status = "W" Then    ' Order in process (i.e. order is validated) or Order Waiting (i.e. stop/limit that was validated)
        If order.Status = "E" Or order.Status = "P" Or order.Status = "W" Then    ' Order in process (i.e. order is validated) or Order Waiting (i.e. stop/limit that was validated)
            LogFile("   processOrder2: " + "Changing Orderid from " + order.RequestTXT + " to " + order.OrderID)
            'LastOrderAccountID = order.AccountID
            'LastOrderOrderID = order.OrderID
            If order.RequestTXT <> order.OrderID Then
                TradePump_SetOrderId(order.RequestTXT, order.OrderID)
                LogFile("   processOrder3: " + "TradePump_SetOrderID " + order.RequestTXT + "->" + order.OrderID)
            End If
        ElseIf order.Status = "F" Then  ' Order Filled Completely
            If order.FilledAmount > 0 Then
                TradePump_OrderFilled(order.OrderID, order.FilledAmount, order.ExecutionRate)
            Else
                TradePump_OrderFilled(order.OrderID, order.Amount, order.ExecutionRate)   ' DRW 3/4/2012  Jeff's demo account was getting FilledAmount = 0 in executed order status?!
            End If
        ElseIf order.Status = "C" Or order.Status = "T" Then   ' Order Canceled or Expired
            LogFile("   processOrder4: " + "Order Canceled  sOrderId=" + order.OrderID + "   RequestTXT=" + CStr(order.RequestTXT))
            TradePump_OrderCanceled(order.OrderID)
        Else
            LogFile("   processOrder5: " + "Status=" + statusstring + " (" + order.Status + ")   RequestTXT=" + CStr(order.RequestTXT) + "  FilledAmount=" + CStr(order.FilledAmount) + "  ExecutionRate=" + CStr(order.ExecutionRate) + "OrderID=" + CStr(order.OrderID) + " OfferID=" + CStr(order.OfferID) + " TradeID=" + CStr(order.TradeID) + " AccountID=" + CStr(order.AccountID) + " AccountName=" + CStr(order.AccountName) + " AccountKind=" + CStr(order.AccountKind) + " Amount=" + CStr(order.Amount) + " BuySell=" + CStr(order.BuySell) + " Rate=" + CStr(order.Rate) + " RateMin=" + CStr(order.RateMin) + " RateMax=" + CStr(order.RateMax) + " ExecutionRate=" + CStr(order.ExecutionRate) + " TimeInForce=" + CStr(order.TimeInForce) + " LifeTime=" + CStr(order.Lifetime) + " Status=" + CStr(order.Status) + " StatusTime=" + CStr(order.StatusTime) + " Type=" + CStr(order.Type) + " NetQuantity=" + CStr(order.NetQuantity) + " TrailStep=" + CStr(order.TrailStep) + " TrailRate=" + CStr(order.TrailRate) + " PegType=" + CStr(order.PegType) + " PegOffset=" + CStr(order.PegOffset) + " ContingentOrderID=" + CStr(order.ContingentOrderID) + " WorkingIndicator=" + CStr(order.WorkingIndicator) + " ContingencyType=" + CStr(order.ContingencyType) + " PrimaryID=" + CStr(order.PrimaryID) + " OriginAmount=" + CStr(order.OriginAmount) + " FilledAmount=" + CStr(order.FilledAmount) + " RequestID=" + CStr(order.RequestID) + " RequestTXT=" + CStr(order.RequestTXT) + " ExpireDate=" + CStr(order.ExpireDate) + " ValueDate=" + CStr(order.ValueDate) + " Parties=" + CStr(order.Parties))
        End If
    End Sub

    Private Sub processTrade(trade As O2GTradeRow)
        LogFile("processTrade: " + "TradeID =" + CStr(trade.TradeID) + " OfferID=" + CStr(trade.OfferID) + " AccountID=" + CStr(trade.AccountID) + " AccountName=" + CStr(trade.AccountName) + " AccountKind=" + CStr(trade.AccountKind) + " BuySell=" + CStr(trade.BuySell) + " Commission=" + CStr(trade.Commission) + " RollInt=" + CStr(trade.RolloverInterest) + " Amount=" + CStr(trade.Amount) + " Open=" + CStr(trade.OpenRate) + " OpenOrderID=" + CStr(trade.OpenOrderID) + " OpenOrderReqID=" + CStr(trade.OpenOrderReqID) + " RequestTXT=" + CStr(trade.OpenOrderRequestTXT) + " QuoteID=" + CStr(trade.OpenQuoteID) + " Time=" + CStr(trade.OpenTime) + " UsedMargin=" + CStr(trade.UsedMargin) + " TradeIDOrigin=" + CStr(trade.TradeIDOrigin) + " Parties=" + CStr(trade.Parties))
    End Sub

    Private Sub processClosedTrade(closedTrade As O2GClosedTradeRow)
        LogFile("processClosedTrade: " + "TradeID=" + CStr(closedTrade.TradeID) + " OfferID=" + CStr(closedTrade.OfferID) + " AccountID=" + CStr(closedTrade.AccountID) + " AccountName=" + CStr(closedTrade.AccountName) + " AccountKind=" + CStr(closedTrade.AccountKind) + " BuySell=" + CStr(closedTrade.BuySell) + " CloseRate=" + CStr(closedTrade.CloseRate) + " CloseOrderID=" + CStr(closedTrade.CloseOrderID) + " CloseOrderReqID=" + CStr(closedTrade.CloseOrderReqID) + " CloseOrderRequestTXT=" + CStr(closedTrade.CloseOrderRequestTXT) + " CloseQuoteID=" + CStr(closedTrade.CloseQuoteID) + " CloseOrderParties=" + CStr(closedTrade.CloseOrderParties) + " CloseTime=" + CStr(closedTrade.CloseTime) + " Commission=" + CStr(closedTrade.Commission) + " GrossPL=" + CStr(closedTrade.GrossPL) + " RolloverInterest=" + CStr(closedTrade.RolloverInterest) + " Amount=" + CStr(closedTrade.Amount) + " OpenRate=" + CStr(closedTrade.OpenRate) + " OpenOrderID=" + CStr(closedTrade.OpenOrderID) + " OpenOrderReqID=" + CStr(closedTrade.OpenOrderReqID) + " OpenOrderRequestTXT=" + CStr(closedTrade.OpenOrderRequestTXT) + " OpenQuoteID=" + CStr(closedTrade.OpenQuoteID) + " OpenOrderParties=" + CStr(closedTrade.OpenOrderParties) + " TradeIDOrigin=" + CStr(closedTrade.TradeIDOrigin) + " TradeIDRemain=" + CStr(closedTrade.TradeIDRemain) + " ValueDate=" + CStr(closedTrade.ValueDate))
    End Sub
#End If

    Private Sub processMsgBox(message As O2GMessageRow)
        ' Check message feature   1: Plain message.    2: Trading hours.   3: Questions.   4: Information.   5: Market conditions.   6: Software    Update.   7: Emergency.  8: System.
        If message.Feature = "5" Or message.Feature = "7" Or message.Feature = "8" Then
            LogFile("**** processMessage: " + "MsgID=" + CStr(message.MsgID) + " Feature=" + CStr(message.Feature) + " From=" + CStr(message.From) + " Subject=" + CStr(message.Subject) + " Type=" + CStr(message.Type) + " Time=" + CStr(message.Time) + " Text=" + CStr(message.Text))
            MsgBox(message.Subject + Chr(13) + Chr(13) + message.Text + Chr(13) + Chr(13) + CStr(message.Time), MsgBoxStyle.SystemModal)
        Else
            LogFile("  processMessage: " + "MsgID=" + CStr(message.MsgID) + " Feature=" + CStr(message.Feature) + " From=" + CStr(message.From) + " Subject=" + CStr(message.Subject) + " Type=" + CStr(message.Type) + " Time=" + CStr(message.Time) + " Text=" + CStr(message.Text))
        End If
        'MsgBox("MsgID=" + CStr(message.MsgID) + " Feature=" + CStr(message.Feature) + " From=" + CStr(message.From) + " Subject=" + CStr(message.Subject) + " Type=" + CStr(message.Type) + " Time=" + CStr(message.Time) + " Text=" + CStr(message.Text))
    End Sub
End Class

Friend Class mySessionStatusListener
    Implements fxcore2.IO2GSessionStatus
    Private mSession As O2GSession = Nothing
    Private mConnected As Boolean = False
    Private mDiconnected As Boolean = False
    Private mError As String = Nothing
    Private mCode As O2GSessionStatusCode = O2GSessionStatusCode.Unknown
    Private mAccountID As String = ""

    Public ReadOnly Property AccountId() As String
        Get
            If mAccountID = "" Then
                ' get first account from login
                Dim loginRules As O2GLoginRules = mSession.getLoginRules
                If loginRules IsNot Nothing Then
                    Dim factory As O2GResponseReaderFactory = mSession.getResponseReaderFactory
                    Dim accountResponse As O2GResponse = loginRules.getTableRefreshResponse(O2GTableType.Accounts)
                    Dim accountsReader As O2GAccountsTableResponseReader = factory.createAccountsTableReader(accountResponse)
                    Dim account As O2GAccountRow = accountsReader.getRow(0)   ' gets first account

                    mAccountID = account.AccountID
                End If
            End If
            Return mAccountID
        End Get
    End Property

    Public ReadOnly Property Status() As O2GSessionStatusCode
        Get
            Return mCode
        End Get
    End Property

    Public Sub New(ByVal session As O2GSession)
        mSession = session
    End Sub

    Public ReadOnly Property Connected() As Boolean
        Get
            Return mConnected
        End Get
    End Property

    Public ReadOnly Property Disconnected() As Boolean
        Get
            Return mDiconnected
        End Get
    End Property

    Public ReadOnly Property [Error]() As String
        Get
            Return mError
        End Get
    End Property

    Public Sub onSessionStatusChanged(ByVal status As O2GSessionStatusCode) Implements IO2GSessionStatus.onSessionStatusChanged
        LogFile("onSessionStatusChanged: Status = " & status.ToString())
        'MsgBox("Status: " & status.ToString())
        If status = O2GSessionStatusCode.Connected Then
            mConnected = True
            mError = Nothing
        Else
            mConnected = False
            'If status <> O2GSessionStatusCode.Connecting Then  MsgBox("FXCM Status code changed to " + Format$(O2GSessionStatusCode.Connected)) Then
        End If

        If status = O2GSessionStatusCode.Disconnected Then
            mDiconnected = True
        Else
            mDiconnected = False
        End If

        mCode = status
        If status = O2GSessionStatusCode.Connected Then
            Dim rules As O2GLoginRules = mSession.getLoginRules()
            If rules IsNot Nothing Then
                ' Request messages (DRW 2/25/2014 - is this just the FXCM spam messages about seminars, products, etc?)
                If rules.isTableLoadedByDefault(O2GTableType.Messages) Then
                    Dim response As O2GResponse = rules.getTableRefreshResponse(O2GTableType.Messages)
                Else
                    Dim requestFactory As O2GRequestFactory = mSession.getRequestFactory()
                    If requestFactory IsNot Nothing Then
                        Dim request As O2GRequest = requestFactory.createRefreshTableRequest(O2GTableType.Messages)
                        If request IsNot Nothing Then
                            mSession.sendRequest(request)
                        Else
                            LogFile("onSessionStatusChanged1: " + requestFactory.getLastError())
                            'MsgBox("onSessionStatusChanged1: " + requestFactory.getLastError())
                        End If
                    End If
                End If

                ' Request Account info table
                If rules.isTableLoadedByDefault(O2GTableType.Accounts) Then
                    Dim response As O2GResponse = rules.getTableRefreshResponse(O2GTableType.Accounts)
                    Dim readerFactory As O2GResponseReaderFactory = mSession.getResponseReaderFactory()
                    If readerFactory IsNot Nothing Then
                        Dim reader As O2GAccountsTableResponseReader = readerFactory.createAccountsTableReader(response)
                        For i As Integer = 0 To reader.Count - 1
                            processAccount(reader.getRow(i))
                        Next i
                    End If
                Else
                    Dim requestFactory As O2GRequestFactory = mSession.getRequestFactory()
                    If requestFactory IsNot Nothing Then
                        Dim request As O2GRequest = requestFactory.createRefreshTableRequest(O2GTableType.Accounts)
                        If request IsNot Nothing Then
                            mSession.sendRequest(request)
                        Else
                            LogFile("onSessionStatusChanged2: " + requestFactory.getLastError())
                            'MsgBox("onSessionStatusChanged2: " + requestFactory.getLastError())
                        End If
                    End If
                End If

                ' Requests bid/ask quotes table 
                If rules.isTableLoadedByDefault(O2GTableType.Offers) Then
                    Dim response As O2GResponse = rules.getTableRefreshResponse(O2GTableType.Offers)
                    'printOffers(rules.getTableRefreshResponse(O2GTableType.Offers), "onSessionStatusChanged rules.isTableLoadedByDefault(O2GTableType.Offers)")   ' not needed for NST data pump since historical requests will get last values
                Else
                    Dim requestFactory As O2GRequestFactory = mSession.getRequestFactory()
                    If requestFactory IsNot Nothing Then mSession.sendRequest(requestFactory.createRefreshTableRequest(O2GTableType.Offers))
                End If

#If Not DataPump Then
                ' request order statuses
                If rules.isTableLoadedByDefault(O2GTableType.Orders) Then
                    Dim response As O2GResponse = rules.getTableRefreshResponse(O2GTableType.Orders)
                Else
                    Dim requestFactory As O2GRequestFactory = mSession.getRequestFactory()
                    If requestFactory IsNot Nothing Then
                        Dim request As O2GRequest = requestFactory.createRefreshTableRequestByAccount(O2GTableType.Orders, AccountId)
                        If request IsNot Nothing Then
                            mSession.sendRequest(request)
                        Else
                            LogFile("onSessionStatusChanged3: " + requestFactory.getLastError())
                            'MsgBox("onSessionStatusChanged3: " + requestFactory.getLastError())
                        End If
                    End If
                End If

                ' request trades table
                If rules.isTableLoadedByDefault(O2GTableType.Trades) Then
                    Dim response As O2GResponse = rules.getTableRefreshResponse(O2GTableType.Trades)
                Else
                    Dim requestFactory As O2GRequestFactory = mSession.getRequestFactory()
                    If requestFactory IsNot Nothing Then
                        Dim request As O2GRequest = requestFactory.createRefreshTableRequest(O2GTableType.Trades)
                        If request IsNot Nothing Then
                            mSession.sendRequest(request)
                        Else
                            LogFile("onSessionStatusChanged4: " + requestFactory.getLastError())
                            'MsgBox("onSessionStatusChanged4: " + requestFactory.getLastError())
                        End If
                    End If
                End If

                ' Request closed trades
                'If rules.isTableLoadedByDefault(O2GTableType.ClosedTrades) Then
                'Dim response As O2GResponse = rules.getTableRefreshResponse(O2GTableType.ClosedTrades)
                'Else
                'Dim requestFactory As O2GRequestFactory = mSession.getRequestFactory()
                'If requestFactory IsNot Nothing Then mSession.sendRequest(requestFactory.createRefreshTableRequest(O2GTableType.ClosedTrades))
                'End If
#End If

            Else
                LogFile("FXCM LoginRules NULL")
                'MsgBox("FXCM LoginRules NULL")
            End If

            ElseIf status = O2GSessionStatusCode.TradingSessionRequested Then
                Dim descs As O2GSessionDescriptorCollection = mSession.getTradingSessionDescriptors()
                LogFile("status = O2GSessionStatusCode.TradingSessionRequested")
                LogFile("Session descriptors")
                LogFile("id, name, description, requires pin")
                For Each desc As O2GSessionDescriptor In descs
                    LogFile(CStr(desc.Id) + " " + CStr(desc.Name) + " " + CStr(desc.Description) + " " + CStr(desc.RequiresPin))
                Next desc

                If FXCM.strSessionID = "" Then
                    LogFile("Argument for trading session ID is missing")
                Else
                    mSession.setTradingSession(FXCM.strSessionID, FXCM.strPin)
                End If
            End If

    End Sub

    Public Sub onLoginFailed(ByVal err As String) Implements IO2GSessionStatus.onLoginFailed
        LogFile("LoginFailed: " + "Login error: " + err)
        mError = err
    End Sub

    Private Sub processAccount(account As O2GAccountRow)
        LogFile("processAccount: " + "StatusListener processAccount -> AccountID=" + CStr(account.AccountID) + " AccountName=" + CStr(account.AccountName) + " AccountKind=" + CStr(account.AccountKind) + " AmountLimit=" + CStr(account.AmountLimit) + " Balance=" + CStr(account.Balance) + " NonTradeEquity=" + CStr(account.NonTradeEquity) + " M2MEquity=" + CStr(account.M2MEquity) + " UsedMargin=" + CStr(account.UsedMargin) + " UsedMargin3=" + CStr(account.UsedMargin3) + " MarginCallFlag=" + CStr(account.MarginCallFlag) + " LastMarginCallDate=" + CStr(account.LastMarginCallDate) + " MaintenanceType=" + CStr(account.MaintenanceType) + " AmountLimit=" + CStr(account.AmountLimit) + " MaintenanceFlag=" + CStr(account.MaintenanceFlag) + " BaseUnitSize=" + CStr(account.BaseUnitSize) + " LevarageProfileID=" + CStr(account.LeverageProfileID) + " ManagerAccountID=" + CStr(account.ManagerAccountID))
        'ValidateAccount(account.Balance)
        FXCM.AccountBalance = account.Balance
        FXCM.USAccount = Not (account.MaintenanceType = "Y")
    End Sub
End Class

'End Namespace
