﻿Imports System.Windows.Forms
Imports fxcore2
Imports System
Imports System.IO

#Const DataPump = False   ' True -> DataPump  False -> TradePump   ' *** Need to change assembly name to/from "FXCM Data Server" and "FXCM Forex Broker" in My Project

Module MainModule
    ' This moudle is the startup for the data pump/data feed application
    ' It dynamically creates a text box for receiving the data pump events.  

    'Public LastOrderAccountID As String = ""
    'Public LastOrderOrderID As String = ""

    Public Const MinimumRequiredAccountSize As Double = 2000

    Public DataEventsTextBox As TextBox      ' a dynamically created text box to receive data pump events
    Public RealTimeTicksTimer As Timer   ' a dynamicaly created timer to poll data feed for new realtime ticks
    Private RealTimeTicksInterval As Integer = 100  ' 500

    Private RealTimeFXCMSession As New FXCM
    Private RealTimeUpdateInProgress As Boolean = False

    Private TradesFXCMSession As New FXCM

    Public WasLoggedOn As Boolean = False
    Public WasLoggedOnIndex As Long = 0
    Public LogonErrorMessageDisplayed As Boolean = False


    Public Sub Main(ByVal args() As String)
        Try
            'FXCM.TestFXCM()
            'MsgBox("Test done")

#If DataPump Then
            ' ************** Data Feed Interface Startup ****************************
            ' dynamically create the text box that will receive data pump events
            DataEventsTextBox = New TextBox
            AddHandler DataEventsTextBox.TextChanged, AddressOf DataEventsTextBox_TextChanged

            If DataServerType = 2 Then
                ' dynamically create a timer that will poll the data server for tick updates
                RealTimeTicksTimer = New Timer
                RealTimeTicksTimer.Interval = RealTimeTicksInterval
                AddHandler RealTimeTicksTimer.Tick, AddressOf RealTimeTicksTimer_Tick
                RealTimeTicksTimer.Enabled = True
                RealTimeTicksTimer.Start()
            End If

            ' Connect Data Pump
            DataPump_Connect(DataEventsTextBox.Handle.ToInt32)
#Else
        LogFile("---------------------------------------------------------------------------------------------------")
        LogFile("---------------------------------------------------------------------------------------------------")
        LogFile("Trade Pump Connect")
        TradePump_Connect()
#End If

            ' Keep application running until notified that NeuroShell Trader is unloading in TextChanged event
            Application.Run()
            MsgBox("FXCM Server Unloading")
        Catch e As Exception
#If DataPump Then
            MsgBox("FXCM Data Server Error: " + e.ToString(), MsgBoxStyle.SystemModal)
#Else
            MsgBox("FXCM Trade Server Error: " + e.ToString(), MsgBoxStyle.SystemModal)
#End If
        End Try
    End Sub

    'Public Sub ValidateAccount(accountbalance As Double)
    '    If accountbalance < MinimumRequiredAccountSize Then
    '        MsgBox("The FXCM account balance (" + CStr(accountbalance) + ") is lower then the " + CStr(MinimumRequiredAccountSize) + " minimum required to utilize NeuroShell Trader")
    '        LogFile("The FXCM account balance (" + CStr(accountbalance) + ") is lower then the " + CStr(MinimumRequiredAccountSize) + " minimum required to utilize NeuroShell Trader")
    '        End
    '    Else
    ''MsgBox("You're good to go!  The FXCM account balance (" + CStr(accountbalance) + ") is higher then the 5000 minimum required to utilize NeuroShell Trader")
    '        LogFile("Account Validated")
    '    End If
    'End Sub

#If DataPump Then
    Public Sub DataEventsTextBox_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        ' *********************************************************************************
        ' The data pump sends events to the application by changing the text box contents
        ' This is where those events are processed
        ' *********************************************************************************

        Dim Ticker As String
        Dim Description As String
        Dim Category As String
        Dim BarInterval As Single
        Dim StartDate As String
        Dim Columns As New Collection
        Dim ticknumber As Integer

        'DataPumpForm.Text = "etxt=" + DataEventsTextBox.Text

        If DataEventsTextBox.Text = "" Then Exit Sub

        Ticker = ""
        Description = ""
        Category = ""
        StartDate = ""
        Select Case DataPump_ParseString(DataEventsTextBox.Text, Ticker, BarInterval, Description, Category, StartDate, Columns)
            Case NSTDataPumpAPI.DataPumpMessages.MSG_UNLOADEXE
                ' >>>> NeuroShell Trader is ending, so generally the data server should end as well
                'MsgBox("MSG_UNLOADEXE")

                RealTimeFXCMSession.Logoff()
                DataPump_Disconnect()
                RemoveHandler DataEventsTextBox.TextChanged, AddressOf DataEventsTextBox_TextChanged
                End

            Case NSTDataPumpAPI.DataPumpMessages.MSG_USERIDPASSWORD
                ' >>>> The UserIDPassword has changed
                'MsgBox("MSG_USERIDPASSWORD: The userid was changed to =" + UserID + "  password=" + Password)
                Try
                    RealTimeFXCMSession.Logon(UserID, Password)
                Catch e As Exception
                    MsgBox("RealTimeFXCMSession.Logon Exception: " + e.ToString())
                End Try
                'MsgBox("FXCM Login is done using UserID=" + UserID + "  password=" + Password)
            Case NSTDataPumpAPI.DataPumpMessages.MSG_REMOVETICKER
                ' >>>> A ticker symbol is being removed/no longer needed
                'MsgBox("MSG_REMOVETICKER: Ticker=" + Ticker + "  BarInterval=" + CStr(BarInterval))
                ticknumber = DataPump_RemoveTicker(Ticker, BarInterval)

            Case NSTDataPumpAPI.DataPumpMessages.MSG_ADDTICKER
                ' >>>> A new ticker symbol is being added
                'MsgBox("MSG_ADDTICKER: Ticker=" + Ticker + "  BarInterval=" + CStr(BarInterval))
                HistoricalRequest(Ticker, BarInterval, Description, Category, StartDate)
        End Select
    End Sub

    Private Sub RealTimeTicksTimer_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        ' *********************************************************************************
        ' This event polls data from data server
        ' Since FXCM doesn't send all ticks in realtime update events, this is the only
        ' way to guarantee the incoming realtime data will match the historical data
        ' if it is reloaded
        ' *********************************************************************************
        RealTimeTicksTimer.Enabled = False  ' turn off timer while getting latest ticks (so if it takes a while, it doesn't repeat over while old one still in progress)
        RealTimeUpdate()
        RealTimeTicksTimer.Interval = RealTimeTicksInterval
        RealTimeTicksTimer.Enabled = True  ' turn timer back on for getting future ticks
    End Sub

    Public Sub RealTimeUpdate()
        If NumberTickers > 0 And Not RealTimeUpdateInProgress Then ' check that tickers to look for and not already doing realtime update
            RealTimeUpdateInProgress = True
            For j As Integer = 1 To NumberTickers
                If TickerUpdate(j) Then
                    RealTimeFXCMSession.GetLatestBar(j)
                End If
            Next j
            RealTimeUpdateInProgress = False
        End If
    End Sub

    Private Sub HistoricalRequest(strInstrument As String, BarInterval As Single, Description As String, Category As String, strFirstDateTime As String)
        Dim HistoricalFXCMSession As New FXCM

        ' Check if tick history (BarInterval=0) or OHLC price history (BarInterval not equal 0)
        HistoricalFXCMSession.Logon(UserID, Password)
        HistoricalFXCMSession.GetHistoricalData(strInstrument, BarInterval, Description, Category, strFirstDateTime)
        HistoricalFXCMSession.Logoff()
        'MsgBox("HistoricalRequest Logoff Done")
    End Sub
#Else

    ' This code contains the code that links the NSTTradePump to a brokerage
    ' and should be customized as needed for your brokerage/application

    ' The default code is an implementation of connecting to FXCM forex brokerage

    Public Sub LogonOrders(ByVal Account As String, ByVal Password As String, ByRef LoggedOn As Integer)
        LogFile("TradesFXCMSession.Logon")
        LoggedOn = CInt(TradesFXCMSession.Logon(Account, Password))
    End Sub

    Public Function AccountBalance() As Double
        LogFile("TradesFXCMSession.AccountBalance = " + Format$(FXCM.AccountBalance, "###,###,###,###,##0.00"))
        LogFile("TradesFXCMSession.DemoAccount = " + CStr(FXCM.DemoAccount))
        If FXCM.DemoAccount Then
            Return -3
        Else
            Return FXCM.AccountBalance
        End If
    End Function

    Public Sub NewOrder(ByRef OrderId As String, ByVal Action As Integer, ByVal Shares As Integer, ByVal Ticker As String, ByVal OrderType As Integer, ByVal StopPrice As Double, ByVal LimitPrice As Double, ByVal Duration As String, ByVal Exchange As String, ByVal SecType As String, ByVal ChartName As String, ByVal StrategyName As String, ByVal ChartTimeStamp As String)
        LogFile("TradesFXCMSession.CreateOrder(" + OrderId + ", " + Ticker + ", " + Format$(Shares) + ", " + Format$(OrderType) + ", " + Format$(Action) + ", " + Format$(StopPrice) + ", " + Format$(LimitPrice))
        TradesFXCMSession.CreateOrder(OrderId, Ticker, Shares, OrderType, Action, StopPrice, LimitPrice)
    End Sub

    Public Sub CancelOrder(OrderId As String)
        LogFile("TradesFXCMSession.DeleteOrder(" + OrderId + ")")
        TradesFXCMSession.DeleteOrder(OrderId)
    End Sub

    Public Sub ModifyOrder(OrderId As String, StopPrice As Double, LimitPrice As Double)
        If LimitPrice <> 0 Then
            LogFile("TradesFXCMSession.editOrder(" + OrderId + ", limit=" + Format$(LimitPrice) + ")")
            TradesFXCMSession.editOrder(OrderId, LimitPrice)
        Else
            LogFile("TradesFXCMSession.editOrder(" + OrderId + ", stop=" + Format$(LimitPrice) + ")")
            TradesFXCMSession.editOrder(OrderId, StopPrice)
        End If
    End Sub

    Public Sub VerifyTicker(ByVal Ticker As String, ByVal Exchange As String, ByVal SecType As String, ByRef Valid As Integer)
        'MsgBox("Verify Ticker " + Ticker)
        ' nothing needs to be done if all tickers accepted!
        ' however should probably at least make sure it is a valid ticker for brokerage so trading doesn't work later
        LogFile("Verify Ticker " + Ticker)
    End Sub

    Public Sub LogoffOrders()
        LogFile("TradesFXCMSession.Logoff()")
        TradesFXCMSession.Logoff()
    End Sub

    Public Sub UnloadOrders()
        LogFile("UnloadOrders()")
        End
    End Sub

#End If

    Private WRITELOCK As New Object()

    Public Sub LogFile(txt As String)
#If Not DataPump Then
        'Dim stream_writer As StreamWriter

        SyncLock WRITELOCK
            'stream_writer = File.AppendText(System.AppDomain.CurrentDomain.BaseDirectory() + "NST_FXCM.log")
            'stream_writer.WriteLine(DateTime.Now.ToShortDateString() + " " + DateTime.Now.ToLongTimeString() + " - " + txt)
            'stream_writer.Close()
#If DataPump Then
            File.AppendAllText(System.AppDomain.CurrentDomain.BaseDirectory() + "NST-FXCM Data.log", DateTime.Now.ToShortDateString() + " " + DateTime.Now.ToLongTimeString() + " - " + txt + Environment.NewLine)
#Else
            File.AppendAllText(System.AppDomain.CurrentDomain.BaseDirectory() + "NST-FXCM Trade.log", DateTime.Now.ToShortDateString() + " " + DateTime.Now.ToLongTimeString() + " - " + txt + Environment.NewLine)
#End If
        End SyncLock
#End If
    End Sub
End Module
